<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class ItemLoteLancRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function getNrCalculoFolha($dtmescompetec, $nrtipomoviment, $nrorg) {
        $query = "SELECT NRCALCULOFOLHA 
                    FROM FPA_CALCULOFOLHA 
                   WHERE NRORG = $nrorg 
                     AND NRTIPOMOVIMENT = $nrtipomoviment
                     AND DTOCORRENCIA = TO_DATE('$dtmescompetec', 'DD/MM/YYYY') ";

        return $this->connection->fetchAll($query)[0]['NRCALCULOFOLHA'];
    }
    public function updateIdStatusLoteLanc($idstatuslotelanc, $nrlotelancevento, $nrorg) {

      $query = $this->entityManager->getConnection()->prepare("
            UPDATE FPA_LOTELANCEVENTO 
               SET IDSTATUSLOTELANC = :IDSTATUSLOTELANC 
             WHERE NRLOTELANCEVENTO = :NRLOTELANCEVENTO
               AND NRORG = :NRORG
        ");

      $query->execute(
          array(
              "IDSTATUSLOTELANC" => $idstatuslotelanc,
              "NRLOTELANCEVENTO" => $nrlotelancevento,
              "NRORG"            => $nrorg
          )
      );
    }

    public function cancelarLote($nrorg, $nrlotelancevento) {
        $query = $this->entityManager->getConnection()->prepare("
          UPDATE PTO_RESUMOSITUFREQ SET NRLOTELANCEVENTO = NULL WHERE NRORG = :NRORG AND NRLOTELANCEVENTO = :NRLOTELANCEVENTO
        ");

        $query->execute(
            array(
                "NRORG"            => $nrorg,
                "NRLOTELANCEVENTO" => $nrlotelancevento
            )
        );

        $query = $this->entityManager->getConnection()->prepare("
          DELETE FROM FPA_ITECALCFOLHA WHERE NRORG = :NRORG AND NRLOTELANCEVENTO = :NRLOTELANCEVENTO
        ");

        $return = $query->execute(
            array(
                "NRORG"            => $nrorg,
                "NRLOTELANCEVENTO" => $nrlotelancevento
            )
        );
        return $return;
    }

    public function getLiquido($nrvinculom, $nrcalculofolha, $nrorg) {
        $query = "SELECT * 
                    FROM FPA_ITECALCFOLHA 
                   WHERE NRORG = :P_NRORG
                     AND NRVINCULOM = :P_NRVINCULOM
                     AND NRCALCULOFOLHA = :P_NRCALCULOFOLHA
                     AND NREVENTOM in (3030, 3050)";
                     
        $params = array('P_NRORG'=>$nrorg,
                        'P_NRVINCULOM'=>$nrvinculom, 
                        'P_NRCALCULOFOLHA'=>$nrcalculofolha
                        );
                        
        return $this->connection->fetchAll($query, $params);
    }

    public function getIdeventodemonst($nrorgpadrao, $nreventom, $dtmescompetencia, $nrorg) {
        $query = "SELECT IDEVENTODEMONST 
                    FROM FPA_EVENTOH 
                   WHERE (NRORG = '$nrorg' or NRORG = '$nrorgpadrao') 
                     AND NREVENTOH IN 
                              (SELECT NREVENTOH 
                                 FROM FPA_EVENTOH 
                                WHERE NREVENTOM = '$nreventom' 
                                  AND (NRORG = '$nrorg' OR NRORG = '$nrorgpadrao') 
                                  AND DTMESCOMPETENC = 
                                     (SELECT MAX(DTMESCOMPETENC) 
                                        FROM FPA_EVENTOH MAX_EVENTOH 
                                       WHERE MAX_EVENTOH.NREVENTOM = FPA_EVENTOH.NREVENTOM 
                                         AND MAX_EVENTOH.NRORG = FPA_EVENTOH.NRORG 
                                         AND TRUNC(MAX_EVENTOH.DTMESCOMPETENC, 'DD') <= TO_DATE('$dtmescompetencia')))";

        return $this->connection->fetchAll($query);
        
    }
}