<?php

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class TipoMovimentoService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteTipoMovimento($dataset) {
        $nrtipomovimento = $dataset["NRTIPOMOVIMENT"];
        $calcfolha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->findBy(array("nrtipomoviment" => $nrtipomovimento, "nrorg" => $dataset['NRORG']));
        if (isset($calcfolha[0])) {
            throw new \Exception(Messages::HCM01000_FPA_TPMOVIMENTO_ALREADY_EXIST_CALCFOLHA_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $tipomoviment = $this->entityManager->getRepository(Repositories::FPA_TIPOMOVIMENT)->findOneBy(array("nrtipomoviment" => $nrtipomovimento));
            $this->entityManager->remove($tipomoviment);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
}