<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class ESocialEventoRepository {

    protected  $connection;

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

/*====== AS QUERIES ABAIXO FORAM MOVIDAS PARA OS REPOSITORIOS DE DADOS DE EVENTOS DO ESOCIAL ======*/
    /*-------------------------- Métodos para retornar os dados do eventos -----------------------------------------------*/
    /**
     * @param $nrenvio
     * @param $nrchave
     * @return array    Associative array
     */
    public function getDadosS1000($nrenvio, $nrchave, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END nrInsc,
       --idePeriodo
       CASE
        WHEN EM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(EM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),EM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --infoCadastro
       EH.NMRAZSOCESTRUT nmRazao,
       CT.CDESOCIAL classTrib,
       EH.CDNATUJURI natJurid,
       '0' indCoop,
       '0' indConstr,
       '0' indDesFolha,
       '0' indOptRegEletron,
       'N' indEntEd,
       'N' indEtt,
       '' nrRegEtt,
       --dadosIsencao
       NULL dadosIsencao,
       '' ideMinLei,
       '' nrCertif,
       '' dtEmisCertif,
       '' dtVerncCertif,
       '' nrProtRenov,
       '' dtProtRenov,
       '' dtDou,
       '' pagDou,
       --contato
       PR.NMPRINCIPALPARC nmCtt,
       PR.NRINSCRICAOPARC cpfCtt,
       (SELECT MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '01') foneFixo, -- 01=Telefone Principal
       (SELECT MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '02') foneCel, -- 02=Celular Pessoal
       (SELECT MAX(C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
          LEFT JOIN FORMACOMU F ON F.CDFORMACOMU = C.CDFORMACOMU
         WHERE C.NRORG = PN.NRORG
           AND C.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
           AND F.CDFORMACOMU = '05') email, -- 05=Email
       --infoOP
       NULL infoOP,
       '' nrSiafi,
       --infoEFR
       '' infoEFR,
       '' ideEFR,
       '' cnpjEFR,
       --infoEnte
       '' infoEnte,
       '' nmEnte,
       '' uf,
       '' codMunic,
       '' indRPPS,
       '' subteto,
       '' vrSubteto,
       --infoOrgInternacional
       NULL infoOrgInternacional,
       '' indAcordoIsenMulta,
       --softwareHouse getDadosSoftwareHouse
       --infoComplementares
       '1' infoComplementares,
       '1' situacaoPJ,
       '0' indSitPJ,
       NULL situacaoPF,
       '' indSitPF,
       '' novaValidade
       --TO_CHAR(EM.DTINIVIGENCIA, 'YYYY-MM') novaValidade_iniValid,
       --TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') novaValidade_fimValid
  FROM (SELECT DISTINCT GET_NRESTRUTURA_SUPERIOR(EM.NRORG, EM.NRESTRUTURAM, 1, :P_DTMESCOMPETENC) NREMPREGADOR, EM.NRORG
          FROM GPE_PARAMORG PO
          JOIN ESTRUTURAM EM ON PO.NRORG = EM.NRORG
                            AND PO.NRTPESTRUTLEGAL = EM.NRTIPOESTRUTURA
         WHERE PO.NRORG = :P_NRORG) EMP
  JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = EMP.NREMPREGADOR
                    AND EM.NRORG = EMP.NRORG
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Responsável Legal da Estrutura*/
  LEFT JOIN PARCNEGOCIO PR ON PR.NRPARCNEGOCIO = EH.NRPARCENTISIN
                          AND PR.NRORG = EH.NRORG
  LEFT JOIN CNAEFISCAL CF ON CF.CDCNAE = EH.CDCNAE
  LEFT JOIN CLASSTRIBUT CT ON CT.NRCLASSTRIBUT = EH.NRCLASSTRIBUT
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
   AND (EM.DTFIMVIGENCIA >= '01/01/2017' OR EM.DTFIMVIGENCIA IS NULL)
   AND EH.NRESTRUTURAM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @return array    Associative array
     */
    public function getDadosSoftwareHouse() {
        $sql = <<<SQL
SELECT '06348006000130' cnpjSofthouse,
       'PEBBIAN TECNOLOGIA EM SOFT. MOBILE ERP' nmRazao,
       'PEBBIAN' nmCont,
       '03121222300' telefone,
       'teknisa@teknisa.com' email
  FROM DUAL
SQL;
        return $this->connection->fetchAll($sql);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @return array    Associative array
     */
    public function getDadosS1005($nrenvio, $nrchave, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoEstab
       --ideEstab
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') ideEstab_tpInsc,
       PN.NRINSCRICAOPARC ideEstab_nrInsc,
       CASE
        WHEN EM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(EM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),EM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosEstab
       EH.CDCNAE cnaePrep,
       --aliqGilrat
       CF.VRALIQRAT aliqRat,
       EH.VRFAP fap,
       (CF.VRALIQRAT * EH.VRFAP) aliqRatAjust,
       --procAdmJudRat
       '' procAdmJudRat,
       '' tpProc,
       '' nrProc,
       '' codSusp,
       --procAdmJudFap
       '' procAdmJudFap,
       --infoCaepf
       '' infoCaepf,
       '' tpCaepf,
       '' infoObra,
       --indSubstPatrObra
       '' indSubstPatrObra,
       --infoTrab
       '0' regPt,
       --infoApr
       '0' contApr,
       '' nrProcJud,
       '' contEntEd,
       --infoEntEduc getDadosInfoEntEduc
       --infoPCD
       '0' infoPCD,
       '' contPCD,
       '' novaValidade
  FROM (SELECT DISTINCT GET_NRESTRUTURA_SUPERIOR(EM.NRORG, EM.NRESTRUTURAM, 1, :P_DTMESCOMPETENC) NREMPREGADOR, EM.NRORG
          FROM GPE_PARAMORG PO
          JOIN ESTRUTURAM EM ON PO.NRORG = EM.NRORG
                            AND PO.NRTPESTRUTLEGAL = EM.NRTIPOESTRUTURA
         WHERE PO.NRORG = :P_NRORG) EMP
  JOIN ESTRUTURAM EM ON EM.NRESTRUTURAM = EMP.NREMPREGADOR
                    AND EM.NRORG = EMP.NRORG
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  LEFT JOIN PARCNEGOCIO PR ON PR.NRPARCNEGOCIO = EH.NRPARCRESPINF
                          AND PR.NRORG = EH.NRORG
  LEFT JOIN CNAEFISCAL CF ON CF.CDCNAE = EH.CDCNAE
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRTIPOESTRUTURA = :P_NRTIPOESTRUTLEGAL
   AND (EM.DTFIMVIGENCIA >= '01/01/2017' OR EM.DTFIMVIGENCIA IS NULL)
   AND EH.NRESTRUTURAM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTLEGAL" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @return array    Associative array
     */
    public function getDadosInfoEntEduc() {
        return array();
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1010($nrenvio, $nrchave, $nrtabela, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NREVENTOM CHAVE, TM.NRTIPOMOVIMENT NRTABELA,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoRubrica
       --ideRubrica
       EM.NREVENTOM codRubr,
       TM.NRTIPOMOVIMENT ideTabRubr,
       --idePeriodo
       CASE
        WHEN EM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(EM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),EM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA,'YYYY-MM') fimValid,
       --dadosRubrica
       EH.NMEVENTOH dscRubr,
       NR.CDESOCIAL natRubr,
       DECODE(EH.IDEVENTODEMONST,'S','3',DECODE(EM.IDTIPOEVENTO,'PROVENTO','1','DESCONTO','2','ENCARGO','2','TOTAL','3')) tpRubr,
       NVL(CP.CDESOCIAL,'00') codIncCP,
       NVL(IRRF.CDESOCIAL,'00') codIncIRRF,
       NVL(FGTS.CDESOCIAL,'00') codIncFGTS,
       NVL(SIND.CDESOCIAL,'00') codIncSIND,
       DECODE(EM.NREVENTOM, DSR.NREVENTOM, 'S', 'N') repDSR,
       DECODE(EM.NREVENTOM, SAL13.NREVENTOM, 'S', 'N') rep13,
       DECODE(EM.NREVENTOM, FERIAS.NREVENTOM, 'S', 'N') repFerias,
       DECODE(EM.NREVENTOM, AVISO.NREVENTOM, 'S', 'N') repAviso,
       EH.DSOBSERVACAO observacao,
       --ideProcessoCP : CRIAR SELECT
       --ideProcessoIRRF : CRIAR SELECT
       --ideProcessoFGTS : CRIAR SELECT
       --ideProcessoSIND : CRIAR SELECT
       '' novaValidade
       --TO_CHAR(EM.DTINIVIGENCIA,'YYYY-MM') novaValidade_iniValid,
       --TO_CHAR(EM.DTFIMVIGENCIA,'YYYY-MM') novaValidade_fimValid
  FROM FPA_EVENTOM EM
  JOIN FPA_EVENTOH EH ON EH.NREVENTOM = EM.NREVENTOM
                     AND EH.NRORG = EM.NRORG
                     AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH H1
                                               WHERE H1.NREVENTOM = EH.NREVENTOM
                                                 AND H1.NRORG = EH.NRORG
                                                 AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Tipos de Movimento sao usados como tabela*/
  JOIN FPA_TIPOMOVIMENT TM ON TM.NRTIPOMOVIMENT IN (1,2,4,10,19)
  /*Natureza da Rubrica*/
  JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
  /*CONTRIBUICAO PREVIDENCIARIA*/
  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, INC.CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
              WHERE IE.NRTIPOINCIDE IN (2,5,8,11,17,20)
             ) CP ON CP.NREVENTOM = EM.NREVENTOM
                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*IRRF*/
  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, INC.CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
              WHERE IE.NRTIPOINCIDE IN (1,4,7,10,16,19)
             ) IRRF ON IRRF.NREVENTOM = EM.NREVENTOM
                 AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*FGTS*/
  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, INC.CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIAFGTS INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
              WHERE IE.NRTIPOINCIDE IN (3,6,9,12,18,21)
             ) FGTS ON FGTS.NREVENTOM = EM.NREVENTOM
                 AND INSTR(','||FGTS.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*CONTRIBUICAO SINDICAL*/
  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, INC.CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIASIND INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
              WHERE IE.NRTIPOINCIDE IN (0)
             ) SIND ON SIND.NREVENTOM = EM.NREVENTOM
                 AND INSTR(','||SIND.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
  /*REP DSR*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPDSR = 'S') DSR ON DSR.NREVENTOM = EM.NREVENTOM
  /*REP 13*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPDECTERC = 'S') SAL13 ON SAL13.NREVENTOM = EM.NREVENTOM
  /*REP FERIAS*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPFERIAS = 'S') FERIAS ON FERIAS.NREVENTOM = EM.NREVENTOM
  /*REP AVISO*/
  LEFT JOIN (SELECT DISTINCT IE.NREVENTOM
               FROM FPA_TIPOINCIDE TI
               JOIN FPA_INCIDEVENTO IE ON IE.NRTIPOINCIDE = TI.NRTIPOINCIDE
              WHERE TI.IDREPAVISO = 'S') AVISO ON AVISO.NREVENTOM = EM.NREVENTOM
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE (EM.NRORG = :P_NRORG OR EM.NRORG = 0)
   AND EM.NREVENTOM = :P_NRCHAVE
   AND TM.NRTIPOMOVIMENT = :P_NRTABELA
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRTABELA" => $nrtabela,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1020($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoLotacao
       --ideLotacao
       EM.NRESTRUTURAM codLotacao,
       CASE
        WHEN EM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(EM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),EM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosLotacao
       TL.CDESOCIAL tpLotacao,
       CASE WHEN TL.CDESOCIAL IN ('01', '10', '21', '24', '90', '91') THEN '' ELSE DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') END dadosLotacao_tpInsc,
       CASE WHEN TL.CDESOCIAL IN ('01', '10', '21', '24', '90', '91') THEN '' ELSE PN.NRINSCRICAOPARC END dadosLotacao_nrInsc,
       --fpasLotacao
       EH.CDFPAS fpas,
       EH.CDTERCEIRO codTercs,
       '' codTercsSusp,
       --infoProcJudTerceiros
       --procJudTerceiro : CRIAR SELECT
       --infoEmprParcial
       DECODE(TL.CDESOCIAL,'02','','') tpInscContrat,
       DECODE(TL.CDESOCIAL,'02','','') nrInscContrat,
       DECODE(TL.CDESOCIAL,'02','','') tpInscProp,
       DECODE(TL.CDESOCIAL,'02','','') nrInscProp
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Tipo Lotação*/
  JOIN TIPOESTRUTURA TE ON TE.NRTIPOESTRUTURA = EM.NRTIPOESTRUTURA
                       AND (TE.NRORG = EM.NRORG OR TE.NRORG = 0)
  LEFT JOIN ESO_TPLOTATRIBUT TL ON TL.NRTPLOTATRIBUT = TE.NRTPLOTATRIBUT
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRCHAVE
   AND (EM.NRTIPOESTRUTURA = 7 OR EM.NRESTRUTURAM = :P_NRESTRUTURAM)
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1030($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT OM.NROCUPACAOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoCargo
       --ideCargo
       OM.NROCUPACAOM codCargo,
       --idePeriodo
       CASE
        WHEN OM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(OM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),OM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(OM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosCargo
       OH.NMOCUPACAOH nmCargo,
       LPAD(OH.NRCBO,6,'0') codCBO
       --cargoPublico
       --leiCargo
  FROM GPE_OCUPACAOM OM
  JOIN GPE_OCUPACAOH OH ON OH.NROCUPACAOM = OM.NROCUPACAOM
                       AND OH.NRORG = OM.NRORG
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE OM.NRORG = :P_NRORG
   AND OM.NROCUPACAOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1040($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT OM.NROCUPACAOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoFuncao
       --ideFuncao
       OM.NROCUPACAOM codFuncao,
       --idePeriodo
       CASE
        WHEN OM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(OM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),OM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(OM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosFuncao
       OH.NMOCUPACAOH dscFuncao,
       LPAD(OH.NRCBO,6,'0') codCBO
  FROM GPE_OCUPACAOM OM
  JOIN GPE_OCUPACAOH OH ON OH.NROCUPACAOM = OM.NROCUPACAOM
                       AND OH.NRORG = OM.NRORG
                       AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                 WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                   AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                   AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE OM.NRORG = :P_NRORG
   AND OM.NROCUPACAOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1050($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT HH.NRHORDIAM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoHorContratual
       --ideHorContratual
       HH.NRHORDIAM codHorContrat,
       --idePeriodo
       CASE
        WHEN HM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(HM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),HM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(HM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosHorContratual
       TO_CHAR(TO_DATE(DECODE(SUBSTR(IHE.HRENTRADA,1,2),'24','00',SUBSTR(IHE.HRENTRADA,1,2))||SUBSTR(IHE.HRENTRADA,3,2), 'HH24:MI:SS'), 'HH24MI') hrEntr,
       TO_CHAR(TO_DATE(DECODE(SUBSTR(IHS.HRSAIDA,1,2),'24','00',SUBSTR(IHS.HRSAIDA,1,2))||SUBSTR(IHS.HRSAIDA,3,2), 'HH24:MI:SS'), 'HH24MI') hrSaida,
       (SELECT
         SUM(60*
          (24*
           ((TO_DATE(DECODE(SUBSTR(IH.HRSAIDA,1,2),'24','00',SUBSTR(IH.HRSAIDA,1,2))||SUBSTR(IH.HRSAIDA,3,2), 'HH24:MI:SS') +
             DECODE(DECODE(SUBSTR(IH.HRSAIDA,1,2),'24','00',SUBSTR(IH.HRSAIDA,1,2))||SUBSTR(IH.HRSAIDA,3,2),'0000',1,0)) -
            TO_DATE(DECODE(SUBSTR(IH.HRENTRADA,1,2),'24','00',SUBSTR(IH.HRENTRADA,1,2))||SUBSTR(IH.HRENTRADA,3,2), 'HH24:MI:SS'))
          )
         ) DURJORNADA
        FROM GPE_INTERVALOSHORARIO IH
        WHERE IH.NRHORDIAM = HH.NRHORDIAM
        AND IH.NRORG = HH.NRORG
       ) durJornada,
       'S' perHorFlexivel,
       --horarioIntervalo : getDadosS1050horarioIntervalo
       HH.NRORG, HH.NRHORDIAM
  FROM GPE_HORDIAM HM
  JOIN GPE_HORDIAH HH ON HH.NRHORDIAM = HM.NRHORDIAM
                     AND HH.NRORG = HM.NRORG
                     AND HH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                    FROM GPE_HORDIAH
                                                   WHERE GPE_HORDIAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND GPE_HORDIAH.NRHORDIAM = HH.NRHORDIAM
                                                     AND GPE_HORDIAH.NRORG = HH.NRORG)
  LEFT JOIN GPE_INTERVALOSHORARIO IHE ON IHE.NRHORDIAM = HH.NRHORDIAM
                                     AND IHE.NRORG = HH.NRORG
                                     AND IHE.NRINTERVALOHORARIO = (SELECT MIN(NRINTERVALOHORARIO) FROM GPE_INTERVALOSHORARIO WHERE NRHORDIAM = IHE.NRHORDIAM AND NRORG = IHE.NRORG)
  LEFT JOIN GPE_INTERVALOSHORARIO IHS ON IHS.NRHORDIAM = HH.NRHORDIAM
                                     AND IHS.NRORG = HH.NRORG
                                     AND IHS.NRINTERVALOHORARIO = (SELECT MAX(NRINTERVALOHORARIO) FROM GPE_INTERVALOSHORARIO WHERE NRHORDIAM = IHS.NRHORDIAM AND NRORG = IHS.NRORG)
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE (HM.NRORG = :P_NRORG OR HM.NRORG = 0)
   AND HH.IDTIPOHORARIO <> 'F'
   AND HH.NRHORDIAM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrhordiam
     * @return array    Associative array
     */
    public function getDadosS1050horarioIntervalo($nrorg, $nrhordiam) {
        $sql = <<<SQL
SELECT '1' tpInterv,
       (60*
         (24*
           ((TO_DATE(DECODE(SUBSTR(IH.HRSAIDA,1,2),'24','00',SUBSTR(IH.HRSAIDA,1,2))||SUBSTR(IH.HRSAIDA,3,2), 'HH24:MI:SS') +
             DECODE(DECODE(SUBSTR(IH.HRSAIDA,1,2),'24','00',SUBSTR(IH.HRSAIDA,1,2))||SUBSTR(IH.HRSAIDA,3,2),'0000',1,0)) -
            TO_DATE(DECODE(SUBSTR(IH.HRENTRADA,1,2),'24','00',SUBSTR(IH.HRENTRADA,1,2))||SUBSTR(IH.HRENTRADA,3,2), 'HH24:MI:SS'))
         )
       ) durInterv,
       TO_CHAR(TO_DATE(DECODE(SUBSTR(IH.HRENTRADA,1,2),'24','00',SUBSTR(IH.HRENTRADA,1,2))||SUBSTR(IH.HRENTRADA,3,2), 'HH24:MI:SS'), 'HH24MI') iniInterv,
       TO_CHAR(TO_DATE(DECODE(SUBSTR(IH.HRSAIDA,1,2),'24','00',SUBSTR(IH.HRSAIDA,1,2))||SUBSTR(IH.HRSAIDA,3,2), 'HH24:MI:SS'), 'HH24MI') termInterv
  FROM GPE_INTERVALOSHORARIO IH
 WHERE IH.NRORG = :P_NRORG
   AND IH.NRHORDIAM = :P_NRHORDIAM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRHORDIAM" => $nrhordiam
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1060($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT EM.NRESTRUTURAM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --infoAmbiente
       --ideAmbiente
       EM.NRESTRUTURAM codAmb,
       CASE
        WHEN EM.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(EM.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),EM.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(EM.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosAmbiente
       EH.NMESTRUTURAH dscAmb,
       DECODE(TOP.CDTIPOINSCRICAO, NULL, '1', '2') localAmb,
       DECODE(DECODE(TOP.CDTIPOINSCRICAO, NULL, PAR.CDTIPOINSCRICAO, TOP.CDTIPOINSCRICAO),'CNPJ','1','CPF','3','') dadosAmbiente_tpInsc,
       DECODE(TOP.CDTIPOINSCRICAO, NULL, CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END, TOP.NRINSCRICAOPARC) dadosAmbiente_nrInsc,
       --fatorRisco : getDadosS1060fatorRisco
       EM.NRORG, EM.NRESTRUTURAM
  FROM ESTRUTURAM EM
  JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.NRORG = EM.NRORG
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                     AND PN.NRORG = EH.NRORG
  /*Empregador*/
  JOIN ESTRUTURAM EMP ON EMP.NRORG = :P_NRORG
                     AND EMP.NRESTRUTURAM = :P_NRESTRUTURAM
  JOIN ESTRUTURAH EMH ON EMH.NRORG = EMP.NRORG
                     AND EMH.NRESTRUTURAM = EMP.NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Tomador*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTSUP = 7
                             AND TH.NRTIPOESTRUTREL = EM.NRTIPOESTRUTURA
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = EM.NRESTRUTURAM
  LEFT JOIN ESTRUTURAM TOM ON TOM.NRORG = EM.NRORG
                          AND TOM.NRESTRUTURAM = HO.NRESTRUTURAMSUP
  LEFT JOIN PARCNEGOCIO TOP ON TOP.NRORG = TOM.NRORG
                           AND TOP.NRPARCNEGOCIO = TOM.NRPARCNEGOCIO
 WHERE EM.NRORG = :P_NRORG
   AND EM.NRESTRUTURAM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrorg
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1060fatorRisco($nrorg, $nrestruturam) {
        $sql = <<<SQL
SELECT RA.CDESOCIAL codFatRis
  FROM SST_RELESTRUTRISCO ER
  JOIN SST_FATORRISCO FR ON FR.NRORG = ER.NRORG
                        AND FR.NRFATORRISCO = ER.NRFATORRISCO
  JOIN GPE_FATRISCAMB RA ON RA.NRFATRISCAMB = FR.NRFATRISCAMB
 WHERE ER.NRORG = :P_NRORG
   AND ER.NRESTRUTURAM = :P_NRESTRUTURAM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESTRUTURAM" => $nrestruturam
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS1070($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT PR.NRPROCESSADMJUD CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --ideProcesso
       PR.NRTPPROCESSADJU tpProc,
       PR.CDPROCESSADMJUD nrProc,
       --idePeriodo
       CASE
        WHEN PR.DTINIVIGENCIA < TO_DATE('01/01/2018')
        THEN DECODE(:P_NRTPAMBIENTE,2,'2016-01','2018-01')
        ELSE TO_CHAR(GREATEST(PR.DTINIVIGENCIA,DECODE(:P_NRTPAMBIENTE,3,TO_DATE('01/01/2017'),2,TO_DATE('01/01/2016'),1,TO_DATE('01/01/2018'),PR.DTINIVIGENCIA)), 'YYYY-MM')
       END iniValid,
       TO_CHAR(PR.DTFIMVIGENCIA, 'YYYY-MM') fimValid,
       --dadosProc
       DECODE(PN.NRINSCRICAOPARC,EH.CDCNPJESTRUT,'1','2') indAutoria,
       MA.CDESOCIAL indMatProc,
       --dadosProcJud
       PR.SGUFVARAPROADJU ufVara,
       MU.CDMUNICIBGE codMunic,
       PR.CDVARAPROCEADJU idVara,
       --infoSusp :
       PR.NRORG, PR.NRPROCESSADMJUD
  FROM GPE_PROCESSADMJUD PR
  JOIN ESTRUTURAH EH ON EH.NRORG = PR.NRORG
                    AND EH.NRESTRUTURAM = PR.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EH.NRESTRUTURAM
                                                  AND NRORG = EH.NRORG)
  /*Materia*/
  LEFT JOIN GPE_MATEPROCADJU MA ON MA.NRMATERPROCADJU = PR.NRMATERPROCADJU
  /*Autoria*/
  LEFT JOIN PARCNEGOCIO PN ON PN.NRORG = PR.NRPARCNEGOCIO
                     AND PN.NRPARCNEGOCIO = PR.NRPARCNEGOCIO
  /*Vara*/
  LEFT JOIN MUNICIPIO MU ON MU.CDMUNICIPIO = PR.CDMUNIVARPRADJU
                        AND (MU.NRORG = PR.NRORG OR MU.NRORG = 0)
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
 WHERE PR.NRORG = :P_NRORG
   AND PR.NRPROCESSADMJUD = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrorg
     * @param $nrprocessadmjud
     * @return array    Associative array
     */
    public function getDadosS1070infoSusp($nrorg, $nrprocessadmjud) {
        $sql = <<<SQL
SELECT IP.NRITEMPROCADMJUD codSusp,
       SE.CDESOCIAL indSusp,
       TO_CHAR(IP.DTITEMPROCADMJUD, 'YYYY-MM') dtDescisao,
       IP.IDDEPOMONTITPROC indDeposito
  FROM GPE_ITEMPROCADMJUD IP
  LEFT JOIN GPE_SUSPEXIGITPROC SE ON SE.NRSUSPEXIGITPROC = PR.NRSUSPEXIGITPROC
 WHERE IP.NRORG = :P_NRORG
   AND IP.NRPROCESSADMJUD = :P_NRPROCESSADMJUD
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRPROCESSADMJUD" => $nrprocessadmjud
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS2200($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT VM.NRVINCULOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --trabalhador
       PH.NRCPFPESSOA cpfTrab,
       PH.NRPISPASEPPES nisTrab,
       PH.NMPESSOA nmTrab,
       PH.IDSEXOPESSOA sexo,
       RP.CDESOCIAL racaCor,
       EC.CDESOCIAL estCiv,
       GI.CDESOCIAL grauInstr,
       DECODE(VH.NRTPMOVTRANSFM,1,'S','N') indPriEmpr,
       '' nmSoc,
       --nascimento
       TO_CHAR(PH.DTNASCPESSOA,'YYYY-MM-DD') dtNascto,
       MU.CDMUNICIBGE codMunic,
       PH.SGESTADO uf,
       PA.CDESOCIAL paisNascto,
       PB.CDESOCIAL paisNac,
       (SELECT MAX(PN.NMPRINCIPALPARC)
          FROM RELACIONAPARC RP
          JOIN PARCNEGOCIO PN ON RP.NRPARCNEGRELAC = PN.NRPARCNEGOCIO
                             AND RP.NRORG = PN.NRORG
          WHERE VM.NRORG = RP.NRORG
            AND RP.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
            AND RP.NRTIPORELACIONA = 1) nmMae, -- 1=Mae
       (SELECT MAX(PN.NMPRINCIPALPARC)
          FROM RELACIONAPARC RP
          JOIN PARCNEGOCIO PN ON RP.NRPARCNEGRELAC = PN.NRPARCNEGOCIO
                             AND RP.NRORG = PN.NRORG
          WHERE VM.NRORG = RP.NRORG
            AND RP.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
            AND RP.NRTIPORELACIONA = 2) nmPai, -- 2=Pai
       --documentos
       --CTPS
       PH.NRCTPSPESSOA nrCtps,
       SUBSTR(PH.NRSERIECTPSPES,1,5) serieCtps,
       PH.SGUFCTPSPES ufCtps,
       --RIC
       --RG
       PH.NRRGPESSOA nrRg,
       PH.CDEXRGPESSOA rg_orgaoEmissor,
       TO_CHAR(PH.DTEXRGPESSOA,'YYYY-MM-DD') rg_dtExped,
       --RNE
       PH.NRDOCUESTRANG nrRne,
       PH.DSEXPDOCESTR rne_orgaoEmissor,
       '' rne_dtExped,
       --OC
       --CNH
       --So traz dados CNH se tiver UF da CNH (mobile)
       DECODE(PH.SGUFHABCARPES, NULL, '', PH.NRCARTHABPES) nrRegCnh,
       DECODE(PH.SGUFHABCARPES, NULL, '', TO_CHAR(PH.DTHABCARTPES,'YYYY-MM-DD')) cnh_dtExped,
       PH.SGUFHABCARPES ufCnh,
       DECODE(PH.SGUFHABCARPES, NULL, '', TO_CHAR(PH.DTVALHABCARTPES,'YYYY-MM-DD')) cnh_dtValid,
       '' dtPriHab,
       DECODE(PH.SGUFHABCARPES, NULL, '', PH.DSCATEGHABCART) categoriaCnh,
       --endereco
       --brasil
       NVL(LG.CDESOCIAL,'O') tpLograd,
       EP.DSENDERECO dscLograd,
       EP.NRIMOVELENDERECO nrLograd,
       EP.DSCOMPLEENDERECO complemento,
       EP.NMBAIRROENDERECO bairro,
       REPLACE(REPLACE(REPLACE(EP.NRCEPENDERECO,' ',''),'.',''),'-','') cep,
       MP.CDMUNICIBGE brasil_codMunic,
       EP.SGESTADO brasil_uf,
       --exterior
       PC.CDESOCIAL paisResid,
       EE.DSENDERECO exterior_dscLograd,
       EE.NRIMOVELENDERECO exterior_nrLograd,
       EE.DSCOMPLEENDERECO exterior_complemento,
       EE.NMBAIRROENDERECO exterior_bairro,
       ME.NMMUNICIPIO nmCid,
       REPLACE(REPLACE(REPLACE(EE.NRCEPENDERECO,' ',''),'.',''),'-','') codPostal,
       --trabEstrangeiro
       TO_CHAR(PH.NRANOCHEGAPAIS,'YYYY-MM-DD') dtChegada,
       NVL(CT.CDESOCIAL,DECODE(PH.IDPOSVISTOPERM,'S','1','')) classTrabEstang,
       CASE WHEN PH.NRANOCHEGAPAIS IS NOT NULL THEN NVL((SELECT MAX('S')
              FROM RELACIONAPARC R
              JOIN PARCNEGOCIO N ON R.NRPARCNEGRELAC = N.NRPARCNEGOCIO
                                AND R.NRORG = N.NRORG
              JOIN GPE_PESSOA P ON P.NRPARCNEGOCIO = N.NRPARCNEGOCIO
                               AND P.NRORG = N.NRORG
              JOIN GPE_PESSOAH H ON H.NRPESSOA = P.NRPESSOA
                                AND H.NRORG = P.NRORG
                                AND H.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                                         WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND H1.NRPESSOA = H.NRPESSOA
                                                           AND H1.NRORG = H.NRORG)
             WHERE R.NRORG = PE.NRORG
               AND R.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
               AND R.NRTIPORELACIONA = 4 -- 4=Cônjuge
               AND H.CDPAIS = '0055'),'N') END casadoBr,
       CASE WHEN PH.NRANOCHEGAPAIS IS NOT NULL THEN NVL((SELECT MAX('S')
              FROM RELACIONAPARC R
              JOIN PARCNEGOCIO N ON R.NRPARCNEGRELAC = N.NRPARCNEGOCIO
                                AND R.NRORG = N.NRORG
              JOIN GPE_PESSOA P ON P.NRPARCNEGOCIO = N.NRPARCNEGOCIO
                               AND P.NRORG = N.NRORG
              JOIN GPE_PESSOAH H ON H.NRPESSOA = P.NRPESSOA
                                AND H.NRORG = P.NRORG
                                AND H.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                                         WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND H1.NRPESSOA = H.NRPESSOA
                                                           AND H1.NRORG = H.NRORG)
             WHERE R.NRORG = PE.NRORG
               AND R.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
               AND R.NRTIPORELACIONA IN (3, 100001) -- 3=Filho
               AND H.CDPAIS = '0055'),'N') END filhosBr,
       --infoDeficiencia
       DECODE(PH.NRCONDFISPES,'2','S','N') defFisica,
       DECODE(PH.NRCONDFISPES,'4','S','N') defVisual,
       DECODE(PH.NRCONDFISPES,'3','S','N') defAuditiva,
       DECODE(PH.NRCONDFISPES,'5','S','N') defMental,
       DECODE(PH.NRCONDFISPES,'8','S','N') defIntelectual,
       DECODE(PH.NRCONDFISPES,'7','S','N') reabReadap,
       'N' infoCota,
       '' observacao,
       --<<dependentes>>-- getDadosS2200dependente
       --aposentadoria
       DECODE(VM.DTAPOSENTAFGTS,NULL,'','S') trabAposent,
       --contato
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' ',''),'-',''),'(',''),')','')
          FROM COMUNICAPARC C
         WHERE C.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
           AND C.NRORG = PE.NRORG
           AND C.CDFORMACOMU = '01') fonePrinc, -- 1-Telefone principal
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' ',''),'-',''),'(',''),')','')
          FROM COMUNICAPARC C
         WHERE C.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
           AND C.NRORG = PE.NRORG
           AND C.CDFORMACOMU IN ('02','03','04','06')) foneAlternat, -- 2-Celular particular 3-Telefone residencial 4-Telefone comercial 6-Celular comercial
       (SELECT MAX(C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
         WHERE C.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
           AND C.NRORG = PE.NRORG
           AND C.CDFORMACOMU = '05') emailPrinc, -- 5-email
       '' emailAlternat,
       --vinculo
       VM.NRVINCULOM matricula,
       '1' tpRegTrab,
       VH.NRTPREGIMEPREV tpRegPrev,
       '' nrRecInfPrelim,
       CASE WHEN VM.DTADMISSAOVINC < DECODE(:P_NRTPAMBIENTE,1,TO_DATE('01/03/2018'),2,TO_DATE('01/03/2016'),TO_DATE('01/01/2016')) THEN 'S' ELSE 'N' END cadIni,
       --infoRegimeTrab
       --infoCeletista
       TO_CHAR(VM.DTADMISSAOVINC,'YYYY-MM-DD') dtAdm,
       '1' tpAdmissao,
       '1' indAdmissao,
       '1' tpRegJor,
       CASE WHEN VM.NRVINCULOEMPREG IN ('3','4','12','13') THEN '2' ELSE '1' END natAtividade,
       TO_CHAR(ES.DTBASESINDICAL, 'MM') dtBase,
       ES.CDCNPJESTRUT cnpjSindCategProf,
       --FGTS
       DECODE(VM.DTOPCAOFGTS,NULL,'2','1') opcFGTS,
       TO_CHAR(VM.DTOPCAOFGTS,'YYYY-MM-DD') dtOpcFGTS,
       --trabTemporario
       --aprendiz
       --infoEstatutario
       --infoContrato
       VH.NRCARGO codCargo,
       VH.NRFUNCAO codFuncao,
       CE.CDESOCIAL codCateg,
       '' codCarreira,
       '' dtIngrCarr,
       --remuneracao
       SL.VRSALARIO vrSalFx,
       DECODE(SL.IDTPSALARIO,'HORA','1','DIARIO','2','SEMANAL','3','QUINZENAL','4','MENSAL','5','TAREFA','6','7') undSalFixo,
       SUBSTR(SL.DSOBSERVACAO,1,90) dscSalVar,
       --duracao
       CASE WHEN VM.NRVINCULOEMPREG IN (10, 11, 12, 13) THEN '2' ELSE '1' END tpContr,
       CASE WHEN VM.NRVINCULOEMPREG IN (10, 11, 12, 13) THEN TO_CHAR(VH.DTFIMCONTRDETERMIN,'YYYY-MM-DD') ELSE '' END dtTerm,
       CASE WHEN VM.NRVINCULOEMPREG IN (10, 11, 12, 13) THEN 'N' ELSE '' END  clauAsseg, --v_2.3
       CASE WHEN VM.NRVINCULOEMPREG IN (10, 11, 12, 13) THEN 'N' ELSE '' END  clauAssec, --v_2.4.01
       --localTrabalho
       --localTrabGeral
       DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') localTrabGeral_TpInsc,
       PN.NRINSCRICAOPARC localTrabGeral_NrInsc,
       PN.NMPRINCIPALPARC descComp,
       --localTrabDom
       --horContratual
       EH.QTHRSEMESCTRABH qtdHrsSem,
       TJ.CDESOCIAL tpJornada,
       DECODE(TJ.CDESOCIAL,'9',EH.NMESCALATRABH,'') dscTpJorn,
       '0' tmpParc,
       --<<horario>>-- getDadosS2200horario
       --filiacaoSindical
       ES.CDCNPJESTRUT cnpjSindTrab,
       --alvaraJudicial
       --sucessaoVinc
       --afastamento
       TO_CHAR(SF.DTINISITUFUNC,'YYYY-MM-DD') dtIniAfast,
       MA.CDESOCIAL codMotAfast,
       --desligamento
       --TO_CHAR(VM.DTRESCISAOVINC,'YYYY-MM-DD') dtDeslig,
       '' dtDeslig,
       VM.NRVINCULOM, PE.NRORG, PE.NRPARCNEGOCIO, EH.NRESCALATRABM
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  JOIN GPE_TIPOVINCULOH VT ON VT.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
                          AND (VT.NRORG = VM.NRORG OR VT.NRORG = 0 OR VT.NRORG IS NULL)
                          AND VT.IDVINCULOEMPR = 'S'
                          AND VT.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_TIPOVINCULOH
                                                    WHERE GPE_TIPOVINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                      AND GPE_TIPOVINCULOH.NRTIPOVINCULOM = VT.NRTIPOVINCULOM
                                                      AND GPE_TIPOVINCULOH.NRORG = VT.NRORG)
  JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.NRORG = VM.NRORG
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
  /*Local de Trabalho*/
  JOIN ESTRUTURAH ET ON ET.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND ET.NRORG = VH.NRORG
                    AND ET.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = ET.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = ET.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = ET.NRPARCNEGOCIO
                     AND PN.NRORG = ET.NRORG
  /*Dados do Empregado - Dependentes*/
  JOIN GPE_PESSOA PE ON VM.NRPESSOA = PE.NRPESSOA
                    AND VM.NRORG    = PE.NRORG
  JOIN GPE_PESSOAH PH ON PE.NRPESSOA = PH.NRPESSOA
                     AND PE.NRORG    = PH.NRORG
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND GPE_PESSOAH.NRPESSOA = PH.NRPESSOA
                                                 AND GPE_PESSOAH.NRORG = PH.NRORG)
  LEFT JOIN PAIS PA ON PA.CDPAIS = PH.CDPAIS
                   AND (PA.NRORG = PH.NRORG OR PA.NRORG = 0)
  /*Dados do Empregado - Naturalidade*/
  LEFT JOIN MUNICIPIO MU ON MU.CDMUNICIPIO = PH.CDMUNICIPIO
                        AND (MU.NRORG = PH.NRORG OR MU.NRORG = 0)
  LEFT JOIN GPE_NACIONALIDADE NA ON PH.NRNACIONALID = NA.NRNACIONALIDADE
                                AND (PH.NRORG = NA.NRORG OR NA.NRORG = 0)
  LEFT JOIN PAIS PB ON PB.CDPAIS = NA.CDPAIS
                   AND (PB.NRORG = NA.NRORG OR PB.NRORG = 0)
  /*Endereço Principal*/
  LEFT JOIN ENDERECOPARC EP ON PE.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                           AND PE.NRORG = EP.NRORG
                           AND EP.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN MUNICIPIO MP ON MP.CDMUNICIPIO = EP.CDMUNICIPIO
                        AND (MP.NRORG = EP.NRORG OR MP.NRORG = 0)
  /*Endereço Exterior*/
  LEFT JOIN ENDERECOPARC EE ON PE.NRPARCNEGOCIO = EE.NRPARCNEGOCIO
                           AND PE.NRORG = EE.NRORG
                           AND EE.CDTIPOENDERECO = 'EXTERIOR'
  LEFT JOIN MUNICIPIO ME ON ME.CDMUNICIPIO = EE.CDMUNICIPIO
                        AND (ME.NRORG = EE.NRORG OR ME.NRORG = 0)
  LEFT JOIN PAIS PC ON PC.CDPAIS = EE.CDPAIS
                   AND (PC.NRORG = EE.NRORG OR PC.NRORG = 0)
  /*Trabalhador Estrangeiro*/
  LEFT JOIN GPE_CLASSESTRANG CT ON CT.NRCLASSESTRANG = PH.NRCLASSESTRANG
  /*Cargo*/
  LEFT JOIN GPE_OCUPACAOH OH ON OH.NROCUPACAOM = VH.NRCARGO
                            AND OH.NRORG = VH.NRORG
                            AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                      WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                        AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                        AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  /*Salário*/
  LEFT JOIN GPE_ALTESALARIO SL ON SL.NRVINCULOM = VM.NRVINCULOM
                              AND SL.NRORG = VM.NRORG
                              AND SL.DTALTESALARIO = (SELECT MAX(DTALTESALARIO) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC)
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
                              AND SL.NROCORRENCIA =  (SELECT MAX(NROCORRENCIA) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO = SL.DTALTESALARIO
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
  /*Horário*/
  LEFT JOIN GPE_ESCALATRABH EH ON EH.NRESCALATRABM = VH.NRESCALATRABM
                              AND EH.NRORG = VH.NRORG
                              AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                        WHERE GPE_ESCALATRABH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                          AND GPE_ESCALATRABH.NRESCALATRABM = EH.NRESCALATRABM
                                                          AND GPE_ESCALATRABH.NRORG = EH.NRORG)
  LEFT JOIN PTO_TIPOJORNADA TJ ON TJ.NRTPJORNADA = EH.NRTPJORNADA
                              AND (TJ.NRORG = EH.NRORG OR TJ.NRORG = 0)
  /*Afastamento*/
  LEFT JOIN GPE_ALTESITUFUNC SF ON SF.NRVINCULOM = VH.NRVINCULOM
                               AND SF.NRORG = VH.NRORG
                               AND SYSDATE BETWEEN SF.DTINISITUFUNC AND NVL(SF.DTFIMSITUFUNC,SYSDATE)
                               AND SF.NRSITUFUNCM NOT IN (1,13)
                               AND SF.NRMOTIVOAFASTA IS NOT NULL
  LEFT JOIN GPE_MOTIVOAFASTA MA ON MA.NRMOTIVOAFASTA = SF.NRMOTIVOAFASTA
                               AND (MA.NRORG = SF.NRORG OR MA.NRORG = 0)
  /*Sindicato*/
  LEFT JOIN ESTRUTURAH ES ON ES.NRESTRUTURAM = VH.NRESTRUTSIND
                         AND ES.NRORG = VH.NRORG
                         AND ES.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                   WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND ESTRUTURAH.NRESTRUTURAM = ES.NRESTRUTURAM
                                                     AND ESTRUTURAH.NRORG = ES.NRORG)
  /*RaçaCor*/
  LEFT JOIN GPE_RACAPESSOA RP ON RP.NRRACAPESSOA = PH.NRRACAPESSOA
                             AND (RP.NRORG = PH.NRORG OR RP.NRORG = 0)
  /*Estado Civil*/
  LEFT JOIN ESTADOCIVIL EC ON EC.CDESTACIVIL = PH.CDESTACIVIL
                          AND (EC.NRORG = PH.NRORG OR EC.NRORG = 0)
  /*Grau Instrução*/
  LEFT JOIN GPE_GRAUINSTR GI ON GI.NRGRAUINSTR = PH.NRGRAUINSTR
                            AND (GI.NRORG = PH.NRORG OR GI.NRORG = 0)
  /*Logradouro*/
  LEFT JOIN LOGRADOURO LG ON LG.CDLOGRADOURO = EP.CDLOGRADOURO
                         AND (LG.NRORG = EP.NRORG OR LG.NRORG = 0)
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Parametro do eSocial*/
  LEFT JOIN ESO_PARAMETRO PARAM ON PARAM.NRORG = :P_NRORG
                            AND PARAM.NRESTRUTURAM = :P_NRESTRUTURAM
                            AND PARAM.DTINIVIGENCIA <= :P_DTMESCOMPETENC
                            AND (PARAM.DTFIMVIGENCIA IS NULL OR PARAM.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
 WHERE VM.NRORG = :P_NRORG
   AND VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
   AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC)
   AND VM.NRTIPOVINCULOM = 1 --CLT
   AND VM.NRVINCULOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrpessoa
     * @return array    Associative array
     */
    public function getDadosS2200dependente($nrorg, $nrparcnegocio, $nrvinculom) {
        $sql = <<<SQL
SELECT DISTINCT LPAD(T.CDESOCIAL,2,'0') tpDep,
       H.NMPESSOA nmDep,
       TO_CHAR(H.DTNASCPESSOA,'YYYY-MM-DD') dtNascto,
       H.NRCPFPESSOA cpfDep,
       NVL((SELECT 'S' FROM FPA_DEPVINCULO WHERE NRVINCULOM = :P_NRVINCULOM AND NRPESSOA = P.NRPESSOA AND NRORG = P.NRORG AND NRTIPODEPENDE = '2'),'N') depIRRF,
       NVL((SELECT 'S' FROM FPA_DEPVINCULO WHERE NRVINCULOM = :P_NRVINCULOM AND NRPESSOA = P.NRPESSOA AND NRORG = P.NRORG AND NRTIPODEPENDE = '1'),'N') depSF,
       DECODE(NVL(H.NRCONDFISPES,1),1,'N','S') incTrab
  FROM RELACIONAPARC R
  JOIN TIPORELACIONA T ON (T.NRORG = R.NRORG OR T.NRORG = 0)
                      AND T.NRTIPORELACIONA = R.NRTIPORELACIONA
  JOIN GPE_PESSOA P ON R.NRPARCNEGRELAC = P.NRPARCNEGOCIO
                   AND R.NRORG = P.NRORG
  JOIN GPE_PESSOAH H ON P.NRPESSOA = H.NRPESSOA
                    AND P.NRORG = H.NRORG
                    AND H.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                             WHERE H1.NRPESSOA = P.NRPESSOA
                                               AND H1.NRORG = P.NRORG
                                               AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_DEPVINCULO D ON D.NRPESSOA = P.NRPESSOA
                       AND D.NRORG = P.NRORG
                       AND D.NRVINCULOM = :P_NRVINCULOM
 WHERE R.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
   AND R.NRORG = :P_NRORG
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRPARCNEGOCIO" => $nrparcnegocio,
            "P_NRVINCULOM" => $nrvinculom,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrpessoa
     * @return array    Associative array
     */
    public function getDadosS2200horario($nrorg, $nrescalatrabm) {
        $sql = <<<SQL
SELECT CASE TO_CHAR(TU.DTDATABASE + (HT.NRSEQHORARIO-1), 'DAY')
        WHEN 'SEGUNDA-FEIRA' THEN 1
        WHEN 'TERÇA-FEIRA  ' THEN 2
        WHEN 'QUARTA-FEIRA ' THEN 3
        WHEN 'QUINTA-FEIRA ' THEN 4
        WHEN 'SEXTA-FEIRA  ' THEN 5
        WHEN 'SÁBADO       ' THEN 6
        WHEN 'DOMINGO      ' THEN 7
        ELSE 8 END dia,
       HT.NRHORDIAM codHorContrat
  FROM GPE_TURNO TU
  JOIN GPE_HORARIOTURNO HT ON HT.NRTURNO = TU.NRTURNO
                          AND HT.NRORG = TU.NRORG
  JOIN GPE_HORDIAH HH ON HH.NRHORDIAM = HT.NRHORDIAM
                     AND HH.NRORG = HT.NRORG
                     AND HH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                    FROM GPE_HORDIAH
                                                   WHERE GPE_HORDIAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND GPE_HORDIAH.NRHORDIAM = HH.NRHORDIAM
                                                     AND GPE_HORDIAH.NRORG = HH.NRORG)
 WHERE TU.NRESCALATRABM = :P_NRESCALATRABM
   AND TU.NRORG = :P_NRORG
   AND HH.IDTIPOHORARIO <> 'F'
 ORDER BY HT.NRSEQHORARIO
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRESCALATRABM" => $nrescalatrabm,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        );
        return $this->connection->fetchAll($sql, $params);
    }

    /**
     * @param $nrenvio
     * @param $nrchave
     * @param $nrestruturam
     * @return array    Associative array
     */
    public function getDadosS2300($nrenvio, $nrchave, $nrestruturam, $nrtpambiente) {
        $sql = <<<SQL
SELECT VM.NRVINCULOM CHAVE,
       'ID'||DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','')||RPAD(CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END,14,'0')||TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS')||SUBSTR('00000'||:P_NRENVIO,-5,100) id,
       --ideEmpregador
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') tpInsc,
       CASE WHEN EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END nrInsc,
       --trabalhador
       PH.NRCPFPESSOA cpfTrab,
       PH.NRPISPASEPPES nisTrab,
       PH.NMPESSOA nmTrab,
       PH.IDSEXOPESSOA sexo,
       RP.CDESOCIAL racaCor,
       EC.CDESOCIAL estCiv,
       GI.CDESOCIAL grauInstr,
       '' nmSoc,
       --nascimento
       TO_CHAR(PH.DTNASCPESSOA,'YYYY-MM-DD') dtNascto,
       MU.CDMUNICIBGE codMunic,
       PH.SGESTADO uf,
       PA.CDESOCIAL paisNascto,
       PB.CDESOCIAL paisNac,
       (SELECT MAX(PN.NMPRINCIPALPARC)
          FROM RELACIONAPARC RP
          JOIN PARCNEGOCIO PN ON RP.NRPARCNEGRELAC = PN.NRPARCNEGOCIO
                             AND RP.NRORG = PN.NRORG
          WHERE VM.NRORG = RP.NRORG
            AND RP.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
            AND RP.NRTIPORELACIONA = 1) nmMae, -- 1=Mae
       (SELECT MAX(PN.NMPRINCIPALPARC)
          FROM RELACIONAPARC RP
          JOIN PARCNEGOCIO PN ON RP.NRPARCNEGRELAC = PN.NRPARCNEGOCIO
                             AND RP.NRORG = PN.NRORG
          WHERE VM.NRORG = RP.NRORG
            AND RP.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
            AND RP.NRTIPORELACIONA = 2) nmPai, -- 2=Pai
       --documentos
       --CTPS
       PH.NRCTPSPESSOA nrCtps,
       PH.NRSERIECTPSPES serieCtps,
       PH.SGUFCTPSPES ufCtps,
       --RIC
       --RG
       PH.NRRGPESSOA nrRg,
       PH.CDEXRGPESSOA rg_orgaoEmissor,
       TO_CHAR(PH.DTEXRGPESSOA,'YYYY-MM-DD') rg_dtExped,
       --RNE
       PH.NRDOCUESTRANG nrRne,
       PH.DSEXPDOCESTR rne_orgaoEmissor,
       '' rne_dtExped,
       --OC
       --CNH
       --So traz dados CNH se tiver UF da CNH (mobile)
       DECODE(PH.SGUFHABCARPES, NULL, '', PH.NRCARTHABPES) nrRegCnh,
       DECODE(PH.SGUFHABCARPES, NULL, '', TO_CHAR(PH.DTHABCARTPES,'YYYY-MM-DD')) cnh_dtExped,
       PH.SGUFHABCARPES ufCnh,
       DECODE(PH.SGUFHABCARPES, NULL, '', TO_CHAR(PH.DTVALHABCARTPES,'YYYY-MM-DD')) cnh_dtValid,
       '' dtPriHab,
       DECODE(PH.SGUFHABCARPES, NULL, '', PH.DSCATEGHABCART) categoriaCnh,
       --endereco
       --brasil
       NVL(LG.CDESOCIAL,'O') tpLograd,
       EP.DSENDERECO dscLograd,
       EP.NRIMOVELENDERECO nrLograd,
       EP.DSCOMPLEENDERECO complemento,
       EP.NMBAIRROENDERECO bairro,
       EP.NRCEPENDERECO cep,
       MP.CDMUNICIBGE brasil_codMunic,
       EP.SGESTADO brasil_uf,
       --exterior
       PC.CDESOCIAL paisResid,
       EE.DSENDERECO exterior_dscLograd,
       EE.NRIMOVELENDERECO exterior_nrLograd,
       EE.DSCOMPLEENDERECO exterior_complemento,
       EE.NMBAIRROENDERECO exterior_bairro,
       ME.NMMUNICIPIO nmCid,
       EE.NRCEPENDERECO codPostal,
       --trabEstrangeiro
       TO_CHAR(PH.NRANOCHEGAPAIS,'YYYY-MM-DD') dtChegada,
       NVL(CT.CDESOCIAL,DECODE(PH.IDPOSVISTOPERM,'S','1','')) classTrabEstang,
       CASE WHEN PH.NRANOCHEGAPAIS IS NOT NULL THEN NVL((SELECT MAX('S')
              FROM RELACIONAPARC R
              JOIN PARCNEGOCIO N ON R.NRPARCNEGRELAC = N.NRPARCNEGOCIO
                                AND R.NRORG = N.NRORG
              JOIN GPE_PESSOA P ON P.NRPARCNEGOCIO = N.NRPARCNEGOCIO
                               AND P.NRORG = N.NRORG
              JOIN GPE_PESSOAH H ON H.NRPESSOA = P.NRPESSOA
                                AND H.NRORG = P.NRORG
                                AND H.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                                         WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND H1.NRPESSOA = H.NRPESSOA
                                                           AND H1.NRORG = H.NRORG)
             WHERE R.NRORG = PE.NRORG
               AND R.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
               AND R.NRTIPORELACIONA = 4 -- 4=Cônjuge
               AND H.CDPAIS = '0055'),'N') END casadoBr,
       CASE WHEN PH.NRANOCHEGAPAIS IS NOT NULL THEN NVL((SELECT MAX('S')
              FROM RELACIONAPARC R
              JOIN PARCNEGOCIO N ON R.NRPARCNEGRELAC = N.NRPARCNEGOCIO
                                AND R.NRORG = N.NRORG
              JOIN GPE_PESSOA P ON P.NRPARCNEGOCIO = N.NRPARCNEGOCIO
                               AND P.NRORG = N.NRORG
              JOIN GPE_PESSOAH H ON H.NRPESSOA = P.NRPESSOA
                                AND H.NRORG = P.NRORG
                                AND H.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                                         WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND H1.NRPESSOA = H.NRPESSOA
                                                           AND H1.NRORG = H.NRORG)
             WHERE R.NRORG = PE.NRORG
               AND R.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
               AND R.NRTIPORELACIONA IN (3,100001) -- 3=Filho
               AND H.CDPAIS = '0055'),'N') END filhosBr,
       --infoDeficiencia
       DECODE(PH.NRCONDFISPES,'2','S','N') defFisica,
       DECODE(PH.NRCONDFISPES,'4','S','N') defVisual,
       DECODE(PH.NRCONDFISPES,'3','S','N') defAuditiva,
       DECODE(PH.NRCONDFISPES,'5','S','N') defMental,
       DECODE(PH.NRCONDFISPES,'8','S','N') defIntelectual,
       DECODE(PH.NRCONDFISPES,'7','S','N') reabReadap,
       'N' infoCota,
       '' observacao,
       --<<dependentes>>-- getDadosS2200dependente
       --aposentadoria
       DECODE(VM.DTAPOSENTAFGTS,NULL,'','S') trabAposent,
       --contato
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' ',''),'-',''),'(',''),')','')
          FROM COMUNICAPARC C
         WHERE C.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
           AND C.NRORG = PE.NRORG
           AND C.CDFORMACOMU = '01') fonePrinc, -- 1-Telefone principal
       (SELECT REPLACE(REPLACE(REPLACE(REPLACE(MAX(C.CDPREFIXCOMUPARC||C.CDCOMUNICAPARC),' ',''),'-',''),'(',''),')','')
          FROM COMUNICAPARC C
         WHERE C.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
           AND C.NRORG = PE.NRORG
           AND C.CDFORMACOMU IN ('02','03','04','06')) foneAlternat, -- 2-Celular particular 3-Telefone residencial 4-Telefone comercial 6-Celular comercial
       (SELECT MAX(C.CDCOMUNICAPARC)
          FROM COMUNICAPARC C
         WHERE C.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
           AND C.NRORG = PE.NRORG
           AND C.CDFORMACOMU = '05') emailPrinc, -- 5-email
       '' emailAlternat,
       --infoTSVInicio
       CASE WHEN VM.DTADMISSAOVINC < DECODE(:P_NRTPAMBIENTE,1,TO_DATE('01/03/2018'),2,TO_DATE('01/03/2016'),TO_DATE('01/01/2016')) THEN 'S' ELSE 'N' END cadIni,
       CE.CDESOCIAL codCateg,
       TO_CHAR(VM.DTADMISSAOVINC,'YYYY-MM-DD') dtInicio,
       CASE WHEN CE.CDESOCIAL IN ('201','202','401','731','734','738') THEN (CASE WHEN VM.NRVINCULOEMPREG IN ('3','4','12','13') THEN '2' ELSE '1' END) ELSE '' END natAtividade,
       --infoComplementares
       --cargoFuncao
       CASE WHEN CE.CDESOCIAL IN ('201','202','305','721','722','731','734','738') THEN VH.NRCARGO ELSE NULL END codCargo,
       CASE WHEN CE.CDESOCIAL IN ('201','202','305','721','722','731','734','738') THEN VH.NRFUNCAO ELSE NULL END codFuncao,
       --remuneracao
       CASE WHEN CE.CDESOCIAL IN ('721','722') THEN SL.VRSALARIO ELSE NULL END vrSalFx,
       CASE WHEN CE.CDESOCIAL IN ('721','722') THEN DECODE(SL.IDTPSALARIO,'HORA','1','DIARIO','2','SEMANAL','3','QUINZENAL','4','MENSAL','5','TAREFA','6','7') ELSE '' END undSalFixo,
       CASE WHEN CE.CDESOCIAL IN ('721','722') THEN SUBSTR(SL.DSOBSERVACAO,1,90) ELSE '' END dscSalVar,
       --FGTS
       CASE WHEN CE.CDESOCIAL IN ('721') THEN DECODE(VM.DTOPCAOFGTS,NULL,'2','1') ELSE '' END opcFGTS,
       CASE WHEN CE.CDESOCIAL IN ('721') THEN TO_CHAR(VM.DTOPCAOFGTS,'YYYY-MM-DD') ELSE NULL END dtOpcFGTS,
       --infoDirigenteSindical
       DECODE(CE.CDESOCIAL,'401',CE.NRCATEGESOC,'') categOrig,
       DECODE(CE.CDESOCIAL,'401',ES.CDCNPJESTRUT,'') cnpjOrigem,
       DECODE(CE.CDESOCIAL,'401',TO_CHAR(VM.DTADMISSAOVINC,'YYYY-MM-DD'),'') dtAdmOrig,
       DECODE(CE.CDESOCIAL,'401',VM.CDMATRICULA,'') matricOrig,
       --infoTrabCedido
       DECODE(CE.CDESOCIAL,'410',CE.NRCATEGESOC,'') infoTrabCedido_categOrig,
       DECODE(CE.CDESOCIAL,'410','__cnpjOrigem__','') cnpjCednt,
       DECODE(CE.CDESOCIAL,'410',VM.CDMATRICULA,'') matricCed,
       DECODE(CE.CDESOCIAL,'410',TO_CHAR(VM.DTADMISSAOVINC,'YYYY-MM-DD'),'') dtAdmCed,
       DECODE(CE.CDESOCIAL,'410','1','') tpRegTrab,
       DECODE(CE.CDESOCIAL,'410',VH.NRTPREGIMEPREV,'') tpRegPrev,
       DECODE(CE.CDESOCIAL,'410','__infOnus__','') infOnus,
       --infoEstagiario
       DECODE(CE.CDESOCIAL,'901','N','') natEstagio,
       DECODE(CE.CDESOCIAL,'901',DECODE(GI.CDESOCIAL,'02','1','03','1','04','1','05','1','06','2','07','2','08','4','09','4','8'),'') nivEstagio,
       DECODE(CE.CDESOCIAL,'901','','') areaAtuacao,
       DECODE(CE.CDESOCIAL,'901','','') nrApol,
       DECODE(CE.CDESOCIAL,'901',SL.VRSALARIO,'') vlrBolsa,
       DECODE(CE.CDESOCIAL,'901',TO_CHAR(VH.DTFIMCONTRDETERMIN,'YYYY-MM-DD'),'') dtPrevTerm,
       --instEnsino
       DECODE(CE.CDESOCIAL,'901',IEH.CDCNPJESTRUT,'') cnpjInstEnsino,
       DECODE(CE.CDESOCIAL,'901',NVL(IEH.NMRAZSOCESTRUT,FO.DSINSTITUICAO),'') nmRazao,
       DECODE(CE.CDESOCIAL,'901',IEE.DSENDERECO,'') instEnsino_dscLograd,
       DECODE(CE.CDESOCIAL,'901',IEE.NRIMOVELENDERECO,'') instEnsino_nrLograd,
       DECODE(CE.CDESOCIAL,'901',IEE.NMBAIRROENDERECO,'') instEnsino_bairro,
       DECODE(CE.CDESOCIAL,'901',IEE.NRCEPENDERECO,'') instEnsino_cep,
       DECODE(CE.CDESOCIAL,'901',MIE.CDMUNICIBGE,'') instEnsino_codMunic,
       DECODE(CE.CDESOCIAL,'901',IEE.SGESTADO,'') instEnsino_uf,
       --ageIntegracao
       --supervisorEstagio
       DECODE(CE.CDESOCIAL,'901',PNS.NRINSCRICAOPARC,'') cpfSupervisor,
       DECODE(CE.CDESOCIAL,'901',PNS.NMPRINCIPALPARC,'') nmSuperv,
       VM.NRVINCULOM, PE.NRORG, PE.NRPARCNEGOCIO
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  JOIN GPE_TIPOVINCULOH VT ON VT.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
                          AND (VT.NRORG = VM.NRORG OR VT.NRORG = 0 OR VT.NRORG IS NULL)
                          AND VT.IDVINCULOEMPR = 'S'
                          AND VT.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_TIPOVINCULOH
                                                    WHERE GPE_TIPOVINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                      AND GPE_TIPOVINCULOH.NRTIPOVINCULOM = VT.NRTIPOVINCULOM
                                                      AND GPE_TIPOVINCULOH.NRORG = VT.NRORG)
  JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.NRORG = VM.NRORG
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
  /*Local de Trabalho*/
  JOIN ESTRUTURAH ET ON ET.NRESTRUTURAM = VH.NRESTRUTGEREN
                    AND ET.NRORG = VH.NRORG
                    AND ET.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                              WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                AND ESTRUTURAH.NRESTRUTURAM = ET.NRESTRUTURAM
                                                AND ESTRUTURAH.NRORG = ET.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRPARCNEGOCIO = ET.NRPARCNEGOCIO
                     AND PN.NRORG = ET.NRORG
  /*Dados do Empregado - Dependentes*/
  JOIN GPE_PESSOA PE ON VM.NRPESSOA = PE.NRPESSOA
                    AND VM.NRORG    = PE.NRORG
  JOIN GPE_PESSOAH PH ON PE.NRPESSOA = PH.NRPESSOA
                     AND PE.NRORG    = PH.NRORG
                     AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                               WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND GPE_PESSOAH.NRPESSOA = PH.NRPESSOA
                                                 AND GPE_PESSOAH.NRORG = PH.NRORG)
  LEFT JOIN PAIS PA ON PA.CDPAIS = PH.CDPAIS
                   AND (PA.NRORG = PH.NRORG OR PA.NRORG = 0)
  /*Dados do Empregado - Naturalidade*/
  LEFT JOIN MUNICIPIO MU ON MU.CDMUNICIPIO = PH.CDMUNICIPIO
                        AND (MU.NRORG = PH.NRORG OR MU.NRORG = 0)
  LEFT JOIN GPE_NACIONALIDADE NA ON PH.NRNACIONALID = NA.NRNACIONALIDADE
                                AND (PH.NRORG = NA.NRORG OR NA.NRORG = 0)
  LEFT JOIN PAIS PB ON PB.CDPAIS = NA.CDPAIS
                   AND (PB.NRORG = NA.NRORG OR PB.NRORG = 0)
  /*Endereço Principal*/
  LEFT JOIN ENDERECOPARC EP ON PE.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                           AND PE.NRORG = EP.NRORG
                           AND EP.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN MUNICIPIO MP ON MP.CDMUNICIPIO = EP.CDMUNICIPIO
                        AND (MP.NRORG = EP.NRORG OR MP.NRORG = 0)
  /*Endereço Exterior*/
  LEFT JOIN ENDERECOPARC EE ON PE.NRPARCNEGOCIO = EE.NRPARCNEGOCIO
                           AND PE.NRORG = EE.NRORG
                           AND EE.CDTIPOENDERECO = 'EXTERIOR'
  LEFT JOIN MUNICIPIO ME ON ME.CDMUNICIPIO = EE.CDMUNICIPIO
                        AND (ME.NRORG = EE.NRORG OR ME.NRORG = 0)
  LEFT JOIN PAIS PC ON PC.CDPAIS = EE.CDPAIS
                   AND (PC.NRORG = EE.NRORG OR PC.NRORG = 0)
  /*Trabalhador Estrangeiro*/
  LEFT JOIN GPE_CLASSESTRANG CT ON CT.NRCLASSESTRANG = PH.NRCLASSESTRANG
  /*Cargo*/
  LEFT JOIN GPE_OCUPACAOH OH ON OH.NROCUPACAOM = VH.NRCARGO
                            AND OH.NRORG = VH.NRORG
                            AND OH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                      WHERE GPE_OCUPACAOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                        AND GPE_OCUPACAOH.NROCUPACAOM = OH.NROCUPACAOM
                                                        AND GPE_OCUPACAOH.NRORG = OH.NRORG)
  /*Salário*/
  LEFT JOIN GPE_ALTESALARIO SL ON SL.NRVINCULOM = VM.NRVINCULOM
                              AND SL.NRORG = VM.NRORG
                              AND SL.DTALTESALARIO = (SELECT MAX(DTALTESALARIO) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO <= LAST_DAY(:P_DTMESCOMPETENC)
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
                              AND SL.NROCORRENCIA =  (SELECT MAX(NROCORRENCIA) FROM GPE_ALTESALARIO
                                                       WHERE GPE_ALTESALARIO.DTALTESALARIO = SL.DTALTESALARIO
                                                         AND GPE_ALTESALARIO.NRVINCULOM = SL.NRVINCULOM
                                                         AND GPE_ALTESALARIO.NRORG = SL.NRORG)
  /*Horário*/
  LEFT JOIN GPE_ESCALATRABH EH ON EH.NRESCALATRABM = VH.NRESCALATRABM
                              AND EH.NRORG = VH.NRORG
                              AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                        WHERE GPE_ESCALATRABH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                          AND GPE_ESCALATRABH.NRESCALATRABM = EH.NRESCALATRABM
                                                          AND GPE_ESCALATRABH.NRORG = EH.NRORG)
  LEFT JOIN PTO_TIPOJORNADA TJ ON TJ.NRTPJORNADA = EH.NRTPJORNADA
                              AND (TJ.NRORG = EH.NRORG OR TJ.NRORG = 0)
  /*Afastamento*/
  LEFT JOIN GPE_ALTESITUFUNC SF ON SF.NRVINCULOM = VH.NRVINCULOM
                               AND SF.NRORG = VH.NRORG
                               AND SYSDATE BETWEEN SF.DTINISITUFUNC AND NVL(SF.DTFIMSITUFUNC,SYSDATE)
                               AND SF.NRSITUFUNCM NOT IN (1,13)
                               AND SF.NRMOTIVOAFASTA IS NOT NULL
  LEFT JOIN GPE_MOTIVOAFASTA MA ON MA.NRMOTIVOAFASTA = SF.NRMOTIVOAFASTA
                               AND (MA.NRORG = SF.NRORG OR MA.NRORG = 0)
  /*Sindicato*/
  LEFT JOIN ESTRUTURAH ES ON ES.NRESTRUTURAM = VH.NRESTRUTSIND
                         AND ES.NRORG = VH.NRORG
                         AND ES.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                   WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                     AND ESTRUTURAH.NRESTRUTURAM = ES.NRESTRUTURAM
                                                     AND ESTRUTURAH.NRORG = ES.NRORG)
  /*RaçaCor*/
  LEFT JOIN GPE_RACAPESSOA RP ON RP.NRRACAPESSOA = PH.NRRACAPESSOA
                             AND (RP.NRORG = PH.NRORG OR RP.NRORG = 0)
  /*Estado Civil*/
  LEFT JOIN ESTADOCIVIL EC ON EC.CDESTACIVIL = PH.CDESTACIVIL
                          AND (EC.NRORG = PH.NRORG OR EC.NRORG = 0)
  /*Grau Instrução*/
  LEFT JOIN GPE_GRAUINSTR GI ON GI.NRGRAUINSTR = PH.NRGRAUINSTR
                            AND (GI.NRORG = PH.NRORG OR GI.NRORG = 0)
  /*Logradouro*/
  LEFT JOIN LOGRADOURO LG ON LG.CDLOGRADOURO = EP.CDLOGRADOURO
                         AND (LG.NRORG = EP.NRORG OR LG.NRORG = 0)
  /*Instituição Ensino*/
  LEFT JOIN DES_FORMACAO FO ON FO.NRORG = PE.NRORG
                           AND FO.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                           AND FO.DTINICIO = (SELECT MAX(DTINICIO) FROM DES_FORMACAO
                                               WHERE NRORG = PE.NRORG
                                                 AND NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                                                 AND DTINICIO <= :P_DTMESCOMPETENC
                                                 AND (DTFIM IS NULL OR DTFIM >=:P_DTMESCOMPETENC))
  LEFT JOIN ESTRUTURAH IEH ON IEH.NRORG = FO.NRORG
                          AND IEH.NRESTRUTURAM = FO.NRESTRUTURAM
                          AND IEH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                     WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                       AND NRESTRUTURAM = IEH.NRESTRUTURAM
                                                       AND NRORG = IEH.NRORG)
  LEFT JOIN ENDERECOPARC IEE ON IEE.NRPARCNEGOCIO = IEH.NRPARCNEGOCIO
                            AND IEE.NRORG = IEH.NRORG
                            AND IEE.CDTIPOENDERECO = 'PRINCIPAL'
  LEFT JOIN MUNICIPIO MIE ON MIE.CDMUNICIPIO = IEE.CDMUNICIPIO
                         AND (MIE.NRORG = IEE.NRORG OR MIE.NRORG = 0)
  LEFT JOIN PAIS PIE ON PIE.CDPAIS = IEE.CDPAIS
                    AND (PIE.NRORG = IEE.NRORG OR PIE.NRORG = 0)
  /*Supervisor Estagio*/
  LEFT JOIN PARCNEGOCIO PNS ON PNS.NRPARCNEGOCIO = IEH.NRPARCRESPINF
                           AND PNS.NRORG = IEH.NRORG
  /*Empregador*/
  JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND NRESTRUTURAM = EMH.NRESTRUTURAM
                                                  AND NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Parametro do eSocial*/
  LEFT JOIN ESO_PARAMETRO PARAM ON PARAM.NRORG = :P_NRORG
                            AND PARAM.NRESTRUTURAM = :P_NRESTRUTURAM
                            AND PARAM.DTINIVIGENCIA <= :P_DTMESCOMPETENC
                            AND (PARAM.DTFIMVIGENCIA IS NULL OR PARAM.DTFIMVIGENCIA >= :P_DTMESCOMPETENC)
 WHERE VM.NRORG = :P_NRORG
   AND VH.NRESTRUTLEGAL = :P_NRESTRUTURAM
   AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC)
   AND VM.NRTIPOVINCULOM IN (2,3,10) --Estagiario, Socio, Autonomo
   AND VM.NRVINCULOM = :P_NRCHAVE
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRENVIO" => $nrenvio,
            "P_NRCHAVE" => $nrchave,
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    /**
     * @param $nrpessoa
     * @return array    Associative array
     */
    public function getDadosS2300dependente($nrorg, $nrparcnegocio, $nrvinculom) {
        $sql = <<<SQL
SELECT DISTINCT LPAD(T.CDESOCIAL,2,'0') tpDep,
       H.NMPESSOA nmDep,
       TO_CHAR(H.DTNASCPESSOA,'YYYY-MM-DD') dtNascto,
       H.NRCPFPESSOA cpfDep,
       NVL((SELECT 'S' FROM FPA_DEPVINCULO WHERE NRVINCULOM = :P_NRVINCULOM AND NRPESSOA = P.NRPESSOA AND NRORG = P.NRORG AND NRTIPODEPENDE = '2'),'N') depIRRF,
       NVL((SELECT 'S' FROM FPA_DEPVINCULO WHERE NRVINCULOM = :P_NRVINCULOM AND NRPESSOA = P.NRPESSOA AND NRORG = P.NRORG AND NRTIPODEPENDE = '1'),'N') depSF,
       DECODE(NVL(H.NRCONDFISPES,1),1,'N','S') incTrab
  FROM RELACIONAPARC R
  JOIN TIPORELACIONA T ON (T.NRORG = R.NRORG OR T.NRORG = 0)
                      AND T.NRTIPORELACIONA = R.NRTIPORELACIONA
  JOIN GPE_PESSOA P ON R.NRPARCNEGRELAC = P.NRPARCNEGOCIO
                   AND R.NRORG = P.NRORG
  JOIN GPE_PESSOAH H ON P.NRPESSOA = H.NRPESSOA
                    AND P.NRORG = H.NRORG
                    AND H.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH H1
                                             WHERE H1.NRPESSOA = P.NRPESSOA
                                               AND H1.NRORG = P.NRORG
                                               AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_DEPVINCULO D ON D.NRPESSOA = P.NRPESSOA
                       AND D.NRORG = P.NRORG
                       AND D.NRVINCULOM = :P_NRVINCULOM
 WHERE R.NRPARCNEGOCIO = :P_NRPARCNEGOCIO
   AND R.NRORG = :P_NRORG
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRPARCNEGOCIO" => $nrparcnegocio,
            "P_NRVINCULOM" => $nrvinculom,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
        );
        return $this->connection->fetchAll($sql, $params);
    }

}