<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class MunicipioRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function validaRestricaoChavePrimaria($cdPais, $sgestado, $cdMunicipio, $nmMunicipio, $isNew) {
        
        $tpvalidacao;
        
        if($isNew)
            $tpvalidacao = ' WHERE CDPAIS = :CDPAIS AND SGESTADO = :SGESTADO AND (CDMUNICIPIO = :CDMUNICIPIO OR NMMUNICIPIO = :NMMUNICIPIO) ';
        else    
            $tpvalidacao = ' WHERE CDPAIS = :CDPAIS AND SGESTADO = :SGESTADO AND CDMUNICIPIO <> :CDMUNICIPIO AND NMMUNICIPIO = :NMMUNICIPIO ';
        
        $query = "
                SELECT 
                    COUNT(*)
                FROM MUNICIPIO".$tpvalidacao;

        
        $parameters = 
        [
            "CDPAIS"       => $cdPais,
            "SGESTADO"     => $sgestado,
            "CDMUNICIPIO"  => $cdMunicipio,
            "NMMUNICIPIO"  => $nmMunicipio,
        ];
        $result = $this->connection->fetchAssoc($query, $parameters);

        if($result['COUNT(*)'] > 0) 
            return true;
        else
            return false;
    }

} 

 