<?php

namespace HCM\Util;

class TkFunction
{
    private $params;
    private $code;

    function __construct(array $params, TkCode $code)
    {
        $this->params = $params;
        $this->code = $code;
    }

    function getAsPHP(array $var_names)
    {
        $params = $this->params;
        $new_var_names = $var_names;
        foreach ($this->params as $param)
        {
            $new_var_names[] = $param;
        }

        $code = $this->code->getAsPHP($new_var_names);
        if (strpos($code, ',') === false && strpos($code, '{') === false && strpos($code, 'return') === false)
        {
            $code = 'return ' . $code;
        }


        return <<<FUNCTION
            function {$this->formatParen($params)}
                     use {$this->getUseList($var_names)}
            {
                $code
            }
FUNCTION;
    }

    private function formatParen($list)
    {
        $code = "";

        foreach ($list as $item)
        {
            $code .= "\$$item,";
        }

        $code = substr($code, 0, -1);
        $code = "($code)";
        return $code;
    }

    private function getUseList($var_names)
    {
        //this was added because of a problem when a parameter has the same name as a global
        $var_names = array_diff_key($var_names, $this->params);
        return $this->formatParenRef($var_names);
    }

    private function formatParenRef($list)
    {
        $code = "";

        foreach ($list as $item)
        {
            $code .= "&\$$item,";
        }

        $code = substr($code, 0, -1);
        $code = "($code)";
        return $code;
    }
}