/* Tabela RESPOSINSPEC*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RESPOSINSPEC */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela RESPOSINSPEC, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_CDP_RESPOSINSPEC
AFTER DELETE OR INSERT OR UPDATE
ON RESPOSINSPEC FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN

         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;
         IF :NEW.CDRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo Resposta = ' || NVL(:NEW.CDRESPINSPEC,'') || ' ';
         END IF;
         IF :NEW.NMRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Resposta = ' || NVL(:NEW.NMRESPINSPEC,'') || ' ';
         END IF;
         IF :NEW.IDFAIXRESINS IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo Faixa = ' || NVL(:NEW.IDFAIXRESINS,'') || ' ';
         END IF;
         IF :NEW.VRINIFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Inicial = ' || NVL(:NEW.VRINIFAIXRES,'') || ' ';
         END IF;
         IF :NEW.VRFINFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Final = ' || NVL(:NEW.VRFINFAIXRES,'') || ' ';
         END IF;
         IF :NEW.VRPONTRESINS IS NOT NULL THEN
            V_DESC := V_DESC || 'Pontuao = ' || NVL(:NEW.VRPONTRESINS,'') || ' ';
         END IF;
         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;
         IF :NEW.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'Unidade = ' || NVL(:NEW.SGUNIDADE,'') || ' ';
         END IF;
         IF :NEW.IDRESPPROC IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Processo = ' || NVL(:NEW.IDRESPPROC,'') || ' ';
         END IF;
         IF :NEW.IDSTATUSRESP IS NOT NULL THEN
            V_DESC := V_DESC || 'Status = ' || NVL(:NEW.IDSTATUSRESP,'') || ' ';
         END IF;
         IF :NEW.DTINIFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Data Inicial = ' || NVL(:NEW.DTINIFAIXRES,'') || ' ';
         END IF;
         IF :NEW.DTFINFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Data Final = ' || NVL(:NEW.DTFINFAIXRES,'') || ' ';
         END IF;
         IF :NEW.DTULTATURINS IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:NEW.DTULTATURINS,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDINSPECAO || :NEW.CDRESPINSPEC;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;
         IF :NEW.CDRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo Resposta = ' || NVL(:NEW.CDRESPINSPEC,'') || ' ';
         END IF;
         IF :NEW.NMRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Resposta = ' || NVL(:NEW.NMRESPINSPEC,'') || ' ';
         END IF;
         IF :NEW.IDFAIXRESINS IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo Faixa = ' || NVL(:NEW.IDFAIXRESINS,'') || ' ';
         END IF;
         IF :NEW.VRINIFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Inicial = ' || NVL(:NEW.VRINIFAIXRES,'') || ' ';
         END IF;
         IF :NEW.VRFINFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Final = ' || NVL(:NEW.VRFINFAIXRES,'') || ' ';
         END IF;
         IF :NEW.VRPONTRESINS IS NOT NULL THEN
            V_DESC := V_DESC || 'Pontuao = ' || NVL(:NEW.VRPONTRESINS,'') || ' ';
         END IF;
         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;
         IF :NEW.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'Unidade = ' || NVL(:NEW.SGUNIDADE,'') || ' ';
         END IF;
         IF :NEW.IDRESPPROC IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Processo = ' || NVL(:NEW.IDRESPPROC,'') || ' ';
         END IF;
         IF :NEW.IDSTATUSRESP IS NOT NULL THEN
            V_DESC := V_DESC || 'Status = ' || NVL(:NEW.IDSTATUSRESP,'') || ' ';
         END IF;
         IF :NEW.DTINIFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Data Inicial = ' || NVL(:NEW.DTINIFAIXRES,'') || ' ';
         END IF;
         IF :NEW.DTFINFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Data Final = ' || NVL(:NEW.DTFINFAIXRES,'') || ' ';
         END IF;
         IF :NEW.DTULTATURINS IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:NEW.DTULTATURINS,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDINSPECAO || :NEW.CDRESPINSPEC;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:OLD.CDINSPECAO,'') || ' ';
         END IF;
         IF :OLD.CDRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo Resposta = ' || NVL(:OLD.CDRESPINSPEC,'') || ' ';
         END IF;
         IF :OLD.NMRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Resposta = ' || NVL(:OLD.NMRESPINSPEC,'') || ' ';
         END IF;
         IF :OLD.IDFAIXRESINS IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo Faixa = ' || NVL(:OLD.IDFAIXRESINS,'') || ' ';
         END IF;
         IF :OLD.VRINIFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Inicial = ' || NVL(:OLD.VRINIFAIXRES,'') || ' ';
         END IF;
         IF :OLD.VRFINFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Faixa Final = ' || NVL(:OLD.VRFINFAIXRES,'') || ' ';
         END IF;
         IF :OLD.VRPONTRESINS IS NOT NULL THEN
            V_DESC := V_DESC || 'Pontuao = ' || NVL(:OLD.VRPONTRESINS,'') || ' ';
         END IF;
         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Produto = ' || NVL(:OLD.CDPRODUTO,'') || ' ';
         END IF;
         IF :OLD.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'Unidade = ' || NVL(:OLD.SGUNIDADE,'') || ' ';
         END IF;
         IF :OLD.IDRESPPROC IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Processo = ' || NVL(:OLD.IDRESPPROC,'') || ' ';
         END IF;
         IF :OLD.IDSTATUSRESP IS NOT NULL THEN
            V_DESC := V_DESC || 'Status = ' || NVL(:OLD.IDSTATUSRESP,'') || ' ';
         END IF;
         IF :OLD.DTINIFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Data Inicial = ' || NVL(:OLD.DTINIFAIXRES,'') || ' ';
         END IF;
         IF :OLD.DTFINFAIXRES IS NOT NULL THEN
            V_DESC := V_DESC || 'Data Final = ' || NVL(:OLD.DTFINFAIXRES,'') || ' ';
         END IF;
         IF :OLD.DTULTATURINS IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:OLD.DTULTATURINS,'') || ' ';
         END IF;

         V_ITPESQ     := :OLD.CDINSPECAO || :OLD.CDRESPINSPEC;
         V_IDTIPOOPER := '3';

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('RESPOSINSPEC', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_RESPOSINSPEC','5.85.xxx'); END;
/
