IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U  
           WHERE O.NAME = 'CONFERE_PARTIDA' AND
                 TYPE = 'P' 	         AND
	              U.UID = O.UID      AND
	              U.NAME = USER)                                              
DROP PROCEDURE CONFERE_PARTIDA
GO

CREATE PROCEDURE CONFERE_PARTIDA(
    @P_CDEMPRESA   VARCHAR(2),
    @P_CDLOTE      VARCHAR(20),
    @P_NRLANCLOTE  VARCHAR(6),
    @P_DTMOVI      DATETIME,
    @P_CONSISTE    VARCHAR,
    @P_RETURN      CHAR(1) OUTPUT)
AS
BEGIN
    DECLARE @V_VRDIFERENCA FLOAT;
    DECLARE @V_DTINICCTBL  DATETIME;
    DECLARE @V_DTFINACCTBL DATETIME;
    DECLARE @V_IDCONTGERE  VARCHAR(1);
    DECLARE @V_CONTACTBL   VARCHAR(20);
    DECLARE @V_CDHISTPADR  VARCHAR(4);
    DECLARE @V_CODCOMERC   VARCHAR(21);
    DECLARE @V_CDFILIAL    VARCHAR(4);
    DECLARE @V_CDCENTCUST  VARCHAR(4);
    DECLARE @V_VRRATECCUS  FLOAT;
    DECLARE @V_QTERRO      INT;

    /* VARIAVEIS DO CURSOR C_LANCLOTE */
    DECLARE @C_LANCLOTE_CDEMPRESA     VARCHAR(2);
    DECLARE @C_LANCLOTE_CDLOTE        VARCHAR(20);
    DECLARE @C_LANCLOTE_NRLANCLOTE    VARCHAR(6);
    DECLARE @C_LANCLOTE_NRSEQLANLOTE  VARCHAR(5);
    DECLARE @C_LANCLOTE_CDCONTCTBL    VARCHAR(20);
    DECLARE @C_LANCLOTE_CDHISTPADR    VARCHAR(4);
    DECLARE @C_LANCLOTE_DTLANCLOTE    DATETIME;
    DECLARE @C_LANCLOTE_NRDOCULOTE    VARCHAR(20);
    DECLARE @C_LANCLOTE_DSHISTLOTE    VARCHAR(200);
    DECLARE @C_LANCLOTE_VRLANCLOTE    DOUBLE PRECISION;
    DECLARE @C_LANCLOTE_IDLLOTCOME    VARCHAR(1);
    DECLARE @C_LANCLOTE_CDLLOTCOME    VARCHAR(21);
    DECLARE @C_LANCLOTE_CDREDUZIDO    VARCHAR(20);

    /* VARIAVEIS DO CURSOR C_RATECCUS */
    DECLARE @C_RATECCUS_CDEMPRESA     VARCHAR(2);
    DECLARE @C_RATECCUS_NRLANCLOTE    VARCHAR(6);
    DECLARE @C_RATECCUS_NRSEQLANLOTE  VARCHAR(5);
    DECLARE @C_RATECCUS_CDFILIAL      VARCHAR(4);
    DECLARE @C_RATECCUS_CDCENTCUST    VARCHAR(4);
    DECLARE @C_RATECCUS_VRRATECCUS    DOUBLE PRECISION;

    /* Verifica Diferena Lanamentos Contabeis */

    SELECT @V_VRDIFERENCA = (SUM(VRLANCLOTE))
      FROM LANCLOTE
     WHERE @P_CDEMPRESA  = CDEMPRESA
       AND @P_NRLANCLOTE = NRLANCLOTE;
                                        
    IF @V_VRDIFERENCA <> 0 BEGIN
    /* 01 Total de debitos difere totais de debito */
                                                                    
       SELECT @V_QTERRO = (COUNT(*))
         FROM ERROLANCLOTE
        WHERE @P_CDEMPRESA  = CDEMPRESA
          AND @P_CDLOTE     = CDLOTE
          AND @P_NRLANCLOTE = NRLANCLOTE
          AND CDERROLANCLOTE  = '001';
                              
       IF @V_QTERRO = 0 BEGIN
                      
          INSERT INTO ERROLANCLOTE
             (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
          VALUES
             (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '001');
       END;
    END;

    /* Retorna perodo contbil da empresa */   
    BEGIN
      SELECT 
         @V_DTINICCTBL  = DTINICCONT,
         @V_DTFINACCTBL = DTFINACONT,
         @V_IDCONTGERE  = IDCONTGERE 
      FROM CONTOPECTBL
      WHERE CDEMPRESA = @P_CDEMPRESA;
    END;

    /* VERIFICACAO DOS LANCAMENTOS */

    DECLARE C_LANCLOTE CURSOR FOR (SELECT CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE, CDCONTCTBL,
                                          CDHISTPADR, DTLANCLOTE, NRDOCULOTE, DSHISTLOTE, VRLANCLOTE, 
                                          IDLLOTCOME, CDLLOTCOME, CDREDUZIDO
                                   FROM LANCLOTE
                                   WHERE CDEMPRESA  = @P_CDEMPRESA
                                     AND NRLANCLOTE = @P_NRLANCLOTE) 
                      
    OPEN C_LANCLOTE;
    FETCH NEXT FROM C_LANCLOTE INTO @C_LANCLOTE_CDEMPRESA, @C_LANCLOTE_CDLOTE, @C_LANCLOTE_NRLANCLOTE,
                                    @C_LANCLOTE_NRSEQLANLOTE, @C_LANCLOTE_CDCONTCTBL,@C_LANCLOTE_CDHISTPADR,
                                    @C_LANCLOTE_DTLANCLOTE, @C_LANCLOTE_NRDOCULOTE, @C_LANCLOTE_DSHISTLOTE,
                                    @C_LANCLOTE_VRLANCLOTE, @C_LANCLOTE_IDLLOTCOME, @C_LANCLOTE_CDLLOTCOME,
                                    @C_LANCLOTE_CDREDUZIDO;
                                                              
    WHILE (@@FETCH_STATUS = 0) BEGIN     
                                                       
       IF @V_DTINICCTBL IS NULL OR
          NOT (@V_DTINICCTBL  <= @P_DTMOVI  AND				
               @V_DTFINACCTBL >= @P_DTMOVI) BEGIN
       
         /* 02 data de movimentacao fora doperiodo contabil */       
        
          SELECT @V_QTERRO = (COUNT(*))
          FROM ERROLANCLOTE
          WHERE  @P_CDEMPRESA  = CDEMPRESA
            AND  @P_CDLOTE     = CDLOTE
            AND  @P_NRLANCLOTE = NRLANCLOTE 
            AND CDERROLANCLOTE  = '002';
                                               
          IF @V_QTERRO = 0 BEGIN
             INSERT INTO ERROLANCLOTE
                (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
             VALUES
                (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '002');
          END;          
       END;
     
       IF @P_CONSISTE = 'S' BEGIN
             
         SELECT @V_CONTACTBL = CDCONTCTBL
         FROM CONTCTBL
         WHERE CDCONTCTBL = @C_LANCLOTE_CDCONTCTBL;
                                  
         IF @V_CONTACTBL IS NULL BEGIN
          /* 03 Conta Contabil nao cadastrada */
                                                                                                       
            SELECT @V_QTERRO = (COUNT(*))
            FROM ERROLANCLOTE
            WHERE CDEMPRESA   = @P_CDEMPRESA
              AND CDLOTE      = @P_CDLOTE 
              AND NRLANCLOTE  = @P_NRLANCLOTE 
              AND CDERROLANCLOTE  = '003';
                                          
            IF @V_QTERRO = 0 BEGIN
                                   
               INSERT INTO ERROLANCLOTE
                  (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
               VALUES
                  (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '003');
            END;       
         END;
       END;
          
          
       BEGIN
          SELECT @V_CDHISTPADR = CDHISTPADR
          FROM HISTPADR
          WHERE CDHISTPADR = @C_LANCLOTE_CDHISTPADR;
       END;
       
      IF @V_CDHISTPADR IS NULL BEGIN
      /* 04 Histrico Padrao nao cadastrado */
                                                               
         SELECT @V_QTERRO = (COUNT(*))
         FROM ERROLANCLOTE
         WHERE CDEMPRESA = @P_CDEMPRESA
           AND CDLOTE      = @P_CDLOTE 
           AND NRLANCLOTE  = @P_NRLANCLOTE 
           AND CDERROLANCLOTE  = '004';
                                                             
           IF @V_QTERRO = 0 BEGIN
              INSERT INTO ERROLANCLOTE
                 (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
              VALUES
                 (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '004'); 
           END;
      END;
                                           
      IF @C_LANCLOTE_CDLLOTCOME = 'F' BEGIN
         SELECT @V_CODCOMERC = CDFORNECED
         FROM FORNECEDOR
         WHERE CDFORNECED = @C_LANCLOTE_CDLLOTCOME;
      END;
                                        
      IF @C_LANCLOTE_IDLLOTCOME = 'C' BEGIN
         SELECT @V_CODCOMERC = CDCLIENTE
         FROM CLIENTE
         WHERE CDCLIENTE = @C_LANCLOTE_CDLLOTCOME;
      END;
                                 
      IF @C_LANCLOTE_IDLLOTCOME = 'B' BEGIN
         SELECT @V_CODCOMERC = CDREDUCONT
         FROM CONTCORR
         WHERE CDREDUCONT = @C_LANCLOTE_CDLLOTCOME;
      END;
      
      IF @V_CODCOMERC IS NOT NULL BEGIN
      /* 05 - Cdigo Comercial no cadastrado*/
         SELECT @V_QTERRO = (COUNT(*))
         FROM ERROLANCLOTE
         WHERE CDEMPRESA = @P_CDEMPRESA
           AND CDLOTE = @P_CDLOTE 
           AND NRLANCLOTE = @P_NRLANCLOTE 
           AND CDERROLANCLOTE = '005';
                     
         IF @V_QTERRO = 0 BEGIN
            INSERT INTO ERROLANCLOTE
               (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
            VALUES
               (@P_CDEMPRESA, @P_CDLOTE,@P_NRLANCLOTE, '005');
         END;
      END;
                               
      IF @C_LANCLOTE_VRLANCLOTE = 0 BEGIN
      /* 06 Valor partida zerado */
         SELECT @V_QTERRO = (COUNT(*))
         FROM ERROLANCLOTE
         WHERE CDEMPRESA = @P_CDEMPRESA
           AND CDLOTE = @P_CDLOTE 
           AND NRLANCLOTE = @P_NRLANCLOTE 
           AND CDERROLANCLOTE = '006';
                    
         IF @V_QTERRO = 0 BEGIN
            INSERT INTO ERROLANCLOTE
               (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
            VALUES
               (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '006');
         END;
      END;
                                                                            
      FETCH NEXT FROM C_LANCLOTE INTO @C_LANCLOTE_CDEMPRESA, @C_LANCLOTE_CDLOTE, @C_LANCLOTE_NRLANCLOTE,
                                      @C_LANCLOTE_NRSEQLANLOTE, @C_LANCLOTE_CDCONTCTBL,@C_LANCLOTE_CDHISTPADR,
                                      @C_LANCLOTE_DTLANCLOTE, @C_LANCLOTE_NRDOCULOTE, @C_LANCLOTE_DSHISTLOTE,
                                      @C_LANCLOTE_VRLANCLOTE, @C_LANCLOTE_IDLLOTCOME, @C_LANCLOTE_CDLLOTCOME,
                                      @C_LANCLOTE_CDREDUZIDO;
    END;
                                                           
    /* Verificao dos rateios */
                                                           
    DECLARE C_RATECCUS CURSOR FOR (SELECT CDEMPRESA, NRLANCLOTE, NRSEQLANLOTE,
                                          CDFILIAL, CDCENTCUST, VRRATECCUS
                                   FROM RATECCUS
                                   WHERE CDEMPRESA    = @C_LANCLOTE_CDEMPRESA     AND
                                         NRLANCLOTE   = @C_LANCLOTE_NRLANCLOTE    AND
                                         NRSEQLANLOTE = @C_LANCLOTE_NRSEQLANLOTE)
                                               
    OPEN C_RATECCUS;
    FETCH NEXT FROM C_RATECCUS INTO @C_RATECCUS_CDEMPRESA, @C_RATECCUS_NRLANCLOTE, @C_RATECCUS_NRSEQLANLOTE,
                                    @C_RATECCUS_CDFILIAL, @C_RATECCUS_CDCENTCUST, @C_RATECCUS_VRRATECCUS;
    WHILE (@@FETCH_STATUS = 0) BEGIN                                
                                        
      IF @C_RATECCUS_VRRATECCUS = 0 BEGIN
      /* 07   Valor rateio zerado */
         SELECT @V_QTERRO = (COUNT(*))
         FROM ERROLANCLOTE
         WHERE CDEMPRESA = @P_CDEMPRESA
         AND CDLOTE      = @P_CDLOTE 
         AND NRLANCLOTE  = @P_NRLANCLOTE 
         AND CDERROLANCLOTE  = '007';
         
         IF @V_QTERRO = 0 BEGIN
            INSERT INTO ERROLANCLOTE
               (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
            VALUES
               (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '007');
         END;
      END;
      
      IF @P_CONSISTE = 'S' BEGIN
         SELECT @V_CDFILIAL = CDFILIAL
         FROM FILIAL
         WHERE CDFILIAL = @C_RATECCUS_CDFILIAL;
      END;      
                                    
      IF @V_CDFILIAL IS NULL BEGIN
      /* 08 Filial nao cadastrada */
         SELECT @V_QTERRO = (COUNT(*))
         FROM ERROLANCLOTE
         WHERE CDEMPRESA  = @P_CDEMPRESA
           AND CDLOTE     = @P_CDLOTE 
           AND NRLANCLOTE = @P_NRLANCLOTE 
           AND CDERROLANCLOTE = '008';
              
         IF @V_QTERRO = 0 BEGIN
            INSERT INTO ERROLANCLOTE
               (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
            VALUES
               (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '008');
         END;    
      END;  
                                                
      BEGIN
         SELECT @V_CDCENTCUST = CDCENTCUST
         FROM CENTCUST
         WHERE CDCENTCUST = @C_RATECCUS_CDCENTCUST;
                                     
         IF @V_CDCENTCUST IS NULL BEGIN
            INSERT INTO ERROLANCLOTE
               (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
            VALUES
               (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '009');
         END;
      END;               
      FETCH NEXT FROM C_RATECCUS INTO @C_RATECCUS_CDEMPRESA, @C_RATECCUS_NRLANCLOTE, @C_RATECCUS_NRSEQLANLOTE,
                                      @C_RATECCUS_CDFILIAL, @C_RATECCUS_CDCENTCUST, @C_RATECCUS_VRRATECCUS;
    END;
    /* FIM DA VERFICAO DO RATEIO*/              

      /* Verifica o valor total do rateio com a partida*/
      SELECT @V_VRRATECCUS = (SUM(VRRATECCUS)) 
      FROM RATECCUS
      WHERE CDEMPRESA    = @C_LANCLOTE_CDEMPRESA
        AND NRLANCLOTE   = @C_LANCLOTE_NRLANCLOTE
        AND NRSEQLANLOTE = @C_LANCLOTE_NRLANCLOTE;
      
      IF @V_VRRATECCUS <> @C_LANCLOTE_VRLANCLOTE BEGIN
         /* VALOR DO RATEIO DIFERE DO LANCAMENTO DE LOTE */
         
        INSERT INTO ERROLANCLOTE
          (CDEMPRESA, CDLOTE, NRLANCLOTE, CDERROLANCLOTE)
        VALUES
          (@P_CDEMPRESA, @P_CDLOTE, @P_NRLANCLOTE, '010');
      END;
--   END;
    /* FINAL VERIFICAO DOS LANCAMENTOS */

   SELECT @V_QTERRO = (COUNT(*))
   FROM ERROLANCLOTE
   WHERE CDEMPRESA = @P_CDEMPRESA AND
         NRLANCLOTE = @P_NRLANCLOTE;
         
   IF @V_QTERRO = 0 BEGIN					
      
      UPDATE CAPALOTE
      SET IDLOTE = 'D'
      WHERE CDEMPRESA = @P_CDEMPRESA
      AND CDLOTE = @P_CDLOTE; 
   END;
    
   SET @P_RETURN = 'V'

END;
GO